var labelType, useGradients, nativeTextSupport, animate;

(function() {
  var ua = navigator.userAgent,
      iStuff = ua.match(/iPhone/i) || ua.match(/iPad/i),
      typeOfCanvas = typeof HTMLCanvasElement,
      nativeCanvasSupport = (typeOfCanvas == 'object' || typeOfCanvas == 'function'),
      textSupport = nativeCanvasSupport 
        && (typeof document.createElement('canvas').getContext('2d').fillText == 'function');
  //I'm setting this based on the fact that ExCanvas provides text support for IE
  //and that as of today iPhone/iPad current text support is lame
  labelType = (!nativeCanvasSupport || (textSupport && !iStuff))? 'Native' : 'HTML';
  nativeTextSupport = labelType == 'Native';
  useGradients = nativeCanvasSupport;
  animate = !(iStuff || !nativeCanvasSupport);
})();

var Log = {
  elem: false,
  write: function(text){
    if (!this.elem) 
      this.elem = document.getElementById('log');
    this.elem.innerHTML = text;
    this.elem.style.left = (500 - this.elem.offsetWidth / 2) + 'px';
  }
};


var icicle;

function init(){
  //left panel controls
  controls();
  var json = { "id": "node433", "name": "TOTAL:809.662m3 ",  "data": { "$area": 809.662, "$dim": 809.662, "$color": "#8189B3" },"children":[{ "id": "node431", "name": "STEEL = 214.662m3 ",  "data": { "$area": 214.662, "$dim": 214.662, "$color": "#C8A4AF" }
,"children": [
{ "id": "node60", "name": "1F = 53.865m3 ",  "data": { "$area": 53.865, "$dim": 53.865, "$color": "#B4939D" }
,"children": [
{"id": "node14", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
,{ "id": "node15", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node16", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node17", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node18", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node19", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node20", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node21", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node22", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node23", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
,{ "id": "node24", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node25", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node26", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node27", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node28", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node29", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
,{ "id": "node30", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
]}
,{ "id": "node154", "name": "2F = 53.865m3 ",  "data": { "$area": 53.865, "$dim": 53.865, "$color": "#B4939D" }
,"children": [
{"id": "node78", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node79", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
,{ "id": "node80", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
,{ "id": "node81", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node82", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node83", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node84", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node85", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node86", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node87", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node88", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node89", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node90", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node91", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node92", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node93", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node94", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
]}
,{ "id": "node238", "name": "3F = 50.851m3 ",  "data": { "$area": 50.851, "$dim": 50.851, "$color": "#B4939D" }
,"children": [
{"id": "node179", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node180", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node181", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node182", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node183", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node184", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node185", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node186", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node187", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node188", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node189", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node190", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
,{ "id": "node191", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node192", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
,{ "id": "node193", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node194", "name": "G11|RC-400x800 = 3.152m3 ",  "data": { "$area": 3.152, "$dim": 3.152, "$color": "#B4939D" }}
]}
,{ "id": "node299", "name": "4F = 52.981m3 ",  "data": { "$area": 52.981, "$dim": 52.981, "$color": "#B4939D" }
,"children": [
{"id": "node263", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node264", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node265", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node266", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node267", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node268", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node269", "name": "G11|RC-400x800 = 3.014m3 ",  "data": { "$area": 3.014, "$dim": 3.014, "$color": "#B4939D" }}
,{ "id": "node270", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node271", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node272", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node273", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node274", "name": "G11|RC-400x800 = 3.741m3 ",  "data": { "$area": 3.741, "$dim": 3.741, "$color": "#B4939D" }}
,{ "id": "node275", "name": "G11|RC-400x800 = 2.857m3 ",  "data": { "$area": 2.857, "$dim": 2.857, "$color": "#B4939D" }}
,{ "id": "node276", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node277", "name": "G11|RC-400x800 = 2.857m3 ",  "data": { "$area": 2.857, "$dim": 2.857, "$color": "#B4939D" }}
,{ "id": "node278", "name": "G11|RC-400x800 = 3.018m3 ",  "data": { "$area": 3.018, "$dim": 3.018, "$color": "#B4939D" }}
,{ "id": "node279", "name": "G11|RC-400x800 = 2.857m3 ",  "data": { "$area": 2.857, "$dim": 2.857, "$color": "#B4939D" }}
]}
,{ "id": "node349", "name": "RF = 1.289m3 ",  "data": { "$area": 1.289, "$dim": 1.289, "$color": "#B4939D" }
,"children": [
{"id": "node324", "name": "SC2|H-300x300x10x15x13 = 0.038m3 ",  "data": { "$area": 0.038, "$dim": 0.038, "$color": "#B4939D" }}
,{ "id": "node325", "name": "SC2|H-300x300x10x15x13 = 0.038m3 ",  "data": { "$area": 0.038, "$dim": 0.038, "$color": "#B4939D" }}
,{ "id": "node326", "name": "SC2|H-300x300x10x15x13 = 0.038m3 ",  "data": { "$area": 0.038, "$dim": 0.038, "$color": "#B4939D" }}
,{ "id": "node327", "name": "SC2|H-300x300x10x15x13 = 0.038m3 ",  "data": { "$area": 0.038, "$dim": 0.038, "$color": "#B4939D" }}
,{ "id": "node328", "name": "SC2|H-300x300x10x15x13 = 0.038m3 ",  "data": { "$area": 0.038, "$dim": 0.038, "$color": "#B4939D" }}
,{ "id": "node329", "name": "SC2|H-300x300x10x15x13 = 0.036m3 ",  "data": { "$area": 0.036, "$dim": 0.036, "$color": "#B4939D" }}
,{ "id": "node330", "name": "SC2|H-300x300x10x15x13 = 0.036m3 ",  "data": { "$area": 0.036, "$dim": 0.036, "$color": "#B4939D" }}
,{ "id": "node331", "name": "SC2|H-300x300x10x15x13 = 0.036m3 ",  "data": { "$area": 0.036, "$dim": 0.036, "$color": "#B4939D" }}
,{ "id": "node332", "name": "SC2|H-300x300x10x15x13 = 0.036m3 ",  "data": { "$area": 0.036, "$dim": 0.036, "$color": "#B4939D" }}
,{ "id": "node333", "name": "|L-75x75x9x8.5x6 = 0.013m3 ",  "data": { "$area": 0.013, "$dim": 0.013, "$color": "#B4939D" }}
,{ "id": "node334", "name": "|L-75x75x9x8.5x6 = 0.013m3 ",  "data": { "$area": 0.013, "$dim": 0.013, "$color": "#B4939D" }}
,{ "id": "node335", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node336", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node337", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node338", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node339", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node340", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node341", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node342", "name": "SG1|H-500x200x10x16 = 0.346m3 ",  "data": { "$area": 0.346, "$dim": 0.346, "$color": "#B4939D" }}
,{ "id": "node343", "name": "SG1|H-500x200x10x16 = 0.346m3 ",  "data": { "$area": 0.346, "$dim": 0.346, "$color": "#B4939D" }}
,{ "id": "node344", "name": "|L-75x75x9x8.5x6 = 0.013m3 ",  "data": { "$area": 0.013, "$dim": 0.013, "$color": "#B4939D" }}
,{ "id": "node345", "name": "|L-75x75x9x8.5x6 = 0.013m3 ",  "data": { "$area": 0.013, "$dim": 0.013, "$color": "#B4939D" }}
]}
,{ "id": "node354", "name": "b24|H-248x124x5x8 = 0.037m3 ",  "data": { "$area": 0.037, "$dim": 0.037, "$color": "#C8A4AF" }}
,{ "id": "node355", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#C8A4AF" }}
,{ "id": "node356", "name": "b24|H-248x124x5x8 = 0.031m3 ",  "data": { "$area": 0.031, "$dim": 0.031, "$color": "#C8A4AF" }}
,{ "id": "node386", "name": "4F-STEEL = 1.715m3 ",  "data": { "$area": 1.715, "$dim": 1.715, "$color": "#B4939D" }
,"children": [
{"id": "node358", "name": "SC1|SHS-200x200x12.0x24 = 0.052m3 ",  "data": { "$area": 0.052, "$dim": 0.052, "$color": "#B4939D" }}
,{ "id": "node359", "name": "SC1|SHS-200x200x12.0x24 = 0.052m3 ",  "data": { "$area": 0.052, "$dim": 0.052, "$color": "#B4939D" }}
,{ "id": "node360", "name": "SC1|SHS-200x200x12.0x24 = 0.052m3 ",  "data": { "$area": 0.052, "$dim": 0.052, "$color": "#B4939D" }}
,{ "id": "node361", "name": "SC1|SHS-200x200x12.0x24 = 0.052m3 ",  "data": { "$area": 0.052, "$dim": 0.052, "$color": "#B4939D" }}
,{ "id": "node362", "name": "SC1|SHS-200x200x12.0x24 = 0.061m3 ",  "data": { "$area": 0.061, "$dim": 0.061, "$color": "#B4939D" }}
,{ "id": "node363", "name": "SC1|SHS-200x200x12.0x24 = 0.061m3 ",  "data": { "$area": 0.061, "$dim": 0.061, "$color": "#B4939D" }}
,{ "id": "node364", "name": "b24|H-248x124x5x8 = 0.029m3 ",  "data": { "$area": 0.029, "$dim": 0.029, "$color": "#B4939D" }}
,{ "id": "node365", "name": "b24|H-248x124x5x8 = 0.031m3 ",  "data": { "$area": 0.031, "$dim": 0.031, "$color": "#B4939D" }}
,{ "id": "node366", "name": "b24|H-248x124x5x8 = 0.031m3 ",  "data": { "$area": 0.031, "$dim": 0.031, "$color": "#B4939D" }}
,{ "id": "node367", "name": "b24|H-248x124x5x8 = 0.029m3 ",  "data": { "$area": 0.029, "$dim": 0.029, "$color": "#B4939D" }}
,{ "id": "node368", "name": "b24|H-248x124x5x8 = 0.031m3 ",  "data": { "$area": 0.031, "$dim": 0.031, "$color": "#B4939D" }}
,{ "id": "node369", "name": "b24|H-248x124x5x8 = 0.037m3 ",  "data": { "$area": 0.037, "$dim": 0.037, "$color": "#B4939D" }}
,{ "id": "node370", "name": "b24|H-248x124x5x8 = 0.030m3 ",  "data": { "$area": 0.030, "$dim": 0.030, "$color": "#B4939D" }}
,{ "id": "node371", "name": "b24|H-248x124x5x8 = 0.037m3 ",  "data": { "$area": 0.037, "$dim": 0.037, "$color": "#B4939D" }}
,{ "id": "node372", "name": "b24|H-248x124x5x8 = 0.037m3 ",  "data": { "$area": 0.037, "$dim": 0.037, "$color": "#B4939D" }}
,{ "id": "node373", "name": "SG1|H-500x200x10x16 = 0.053m3 ",  "data": { "$area": 0.053, "$dim": 0.053, "$color": "#B4939D" }}
,{ "id": "node374", "name": "SG1|H-500x200x10x16 = 0.104m3 ",  "data": { "$area": 0.104, "$dim": 0.104, "$color": "#B4939D" }}
,{ "id": "node375", "name": "SG1|H-500x200x10x16 = 0.053m3 ",  "data": { "$area": 0.053, "$dim": 0.053, "$color": "#B4939D" }}
,{ "id": "node376", "name": "SG1|H-500x200x10x16 = 0.103m3 ",  "data": { "$area": 0.103, "$dim": 0.103, "$color": "#B4939D" }}
,{ "id": "node377", "name": "SG1|H-500x200x10x16 = 0.053m3 ",  "data": { "$area": 0.053, "$dim": 0.053, "$color": "#B4939D" }}
,{ "id": "node378", "name": "SG1|H-500x200x10x16 = 0.051m3 ",  "data": { "$area": 0.051, "$dim": 0.051, "$color": "#B4939D" }}
,{ "id": "node379", "name": "SG1|H-500x200x10x16 = 0.108m3 ",  "data": { "$area": 0.108, "$dim": 0.108, "$color": "#B4939D" }}
,{ "id": "node380", "name": "SG1|H-500x200x10x16 = 0.130m3 ",  "data": { "$area": 0.130, "$dim": 0.130, "$color": "#B4939D" }}
,{ "id": "node381", "name": "SG1|H-500x200x10x16 = 0.051m3 ",  "data": { "$area": 0.051, "$dim": 0.051, "$color": "#B4939D" }}
,{ "id": "node382", "name": "SG1|H-500x200x10x16 = 0.051m3 ",  "data": { "$area": 0.051, "$dim": 0.051, "$color": "#B4939D" }}
,{ "id": "node383", "name": "SG1|H-500x200x10x16 = 0.341m3 ",  "data": { "$area": 0.341, "$dim": 0.341, "$color": "#B4939D" }}
]}
]}
,{ "id": "node432", "name": "RC = 595.000m3 ",  "data": { "$area": 595.000, "$dim": 595.000, "$color": "#79C697" }
,"children": [
{ "id": "node61", "name": "1F = 155.882m3 ",  "data": { "$area": 155.882, "$dim": 155.882, "$color": "#6CB287" }
,"children": [
{"id": "node2", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node3", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node4", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node5", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node6", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node7", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node8", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node9", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node10", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node11", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node12", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node13", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node31", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node32", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node33", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node34", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node35", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node36", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node37", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node38", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node39", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node40", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node41", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node42", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node43", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node44", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node45", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node46", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node47", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node48", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node49", "name": "W15|RCW-150 = 5.627m3 ",  "data": { "$area": 5.627, "$dim": 5.627, "$color": "#6CB287" }}
,{ "id": "node50", "name": "W15|RCW-150 = 3.213m3 ",  "data": { "$area": 3.213, "$dim": 3.213, "$color": "#6CB287" }}
,{ "id": "node51", "name": "W15|RCW-150 = 8.208m3 ",  "data": { "$area": 8.208, "$dim": 8.208, "$color": "#6CB287" }}
,{ "id": "node52", "name": "W15|RCW-150 = 1.713m3 ",  "data": { "$area": 1.713, "$dim": 1.713, "$color": "#6CB287" }}
,{ "id": "node53", "name": "W15|RCW-150 = 10.484m3 ",  "data": { "$area": 10.484, "$dim": 10.484, "$color": "#6CB287" }}
,{ "id": "node54", "name": "W15|RCW-150 = 4.705m3 ",  "data": { "$area": 4.705, "$dim": 4.705, "$color": "#6CB287" }}
,{ "id": "node55", "name": "W15|RCW-150 = 3.000m3 ",  "data": { "$area": 3.000, "$dim": 3.000, "$color": "#6CB287" }}
,{ "id": "node56", "name": "W15|RCW-150 = 3.000m3 ",  "data": { "$area": 3.000, "$dim": 3.000, "$color": "#6CB287" }}
]}
,{ "id": "node155", "name": "2F = 141.165m3 ",  "data": { "$area": 141.165, "$dim": 141.165, "$color": "#6CB287" }
,"children": [
{"id": "node66", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node67", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node68", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node69", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node70", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node71", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node72", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node73", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node74", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node75", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node76", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node77", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node95", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node96", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node97", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node98", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node99", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node100", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node101", "name": "RB1|RC-500x800 = 0.899m3 ",  "data": { "$area": 0.899, "$dim": 0.899, "$color": "#6CB287" }}
,{ "id": "node102", "name": "RB1|RC-500x800 = 0.899m3 ",  "data": { "$area": 0.899, "$dim": 0.899, "$color": "#6CB287" }}
,{ "id": "node103", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node104", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node105", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node106", "name": "RB1|RC-500x800 = 0.999m3 ",  "data": { "$area": 0.999, "$dim": 0.999, "$color": "#6CB287" }}
,{ "id": "node107", "name": "RB1|RC-500x800 = 0.999m3 ",  "data": { "$area": 0.999, "$dim": 0.999, "$color": "#6CB287" }}
,{ "id": "node108", "name": "S15|RCSL-150 = 2.741m3 ",  "data": { "$area": 2.741, "$dim": 2.741, "$color": "#6CB287" }}
,{ "id": "node109", "name": "S15|RCSL-150 = 3.439m3 ",  "data": { "$area": 3.439, "$dim": 3.439, "$color": "#6CB287" }}
,{ "id": "node110", "name": "S15|RCSL-150 = 2.873m3 ",  "data": { "$area": 2.873, "$dim": 2.873, "$color": "#6CB287" }}
,{ "id": "node111", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node112", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node113", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node114", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node115", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node116", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node117", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node118", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node119", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node120", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node121", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node122", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
]}
,{ "id": "node239", "name": "3F = 115.932m3 ",  "data": { "$area": 115.932, "$dim": 115.932, "$color": "#6CB287" }
,"children": [
{"id": "node167", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node168", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node169", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node170", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node171", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node172", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node173", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node174", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node175", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node176", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node177", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node178", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node195", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node196", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node197", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node198", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node199", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node200", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node201", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node202", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node203", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node204", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node205", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node206", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node207", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node208", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node209", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node210", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node211", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
,{ "id": "node212", "name": "S15|RCSL-150 = 6.046m3 ",  "data": { "$area": 6.046, "$dim": 6.046, "$color": "#6CB287" }}
]}
,{ "id": "node300", "name": "4F = 93.389m3 ",  "data": { "$area": 93.389, "$dim": 93.389, "$color": "#6CB287" }
,"children": [
{"id": "node255", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node256", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node257", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node258", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node259", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node260", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node261", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node262", "name": "C1|RC-500x500 = 1.250m3 ",  "data": { "$area": 1.250, "$dim": 1.250, "$color": "#6CB287" }}
,{ "id": "node280", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node281", "name": "RB1|RC-500x800 = 3.571m3 ",  "data": { "$area": 3.571, "$dim": 3.571, "$color": "#6CB287" }}
,{ "id": "node282", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node283", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node284", "name": "RB1|RC-500x800 = 3.571m3 ",  "data": { "$area": 3.571, "$dim": 3.571, "$color": "#6CB287" }}
,{ "id": "node285", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node286", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node287", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node288", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
,{ "id": "node289", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node290", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node291", "name": "S15|RCSL-150 = 7.225m3 ",  "data": { "$area": 7.225, "$dim": 7.225, "$color": "#6CB287" }}
,{ "id": "node292", "name": "S15|RCSL-150 = 4.868m3 ",  "data": { "$area": 4.868, "$dim": 4.868, "$color": "#6CB287" }}
,{ "id": "node293", "name": "S15|RCSL-150 = 4.868m3 ",  "data": { "$area": 4.868, "$dim": 4.868, "$color": "#6CB287" }}
,{ "id": "node294", "name": "S15|RCSL-150 = 4.868m3 ",  "data": { "$area": 4.868, "$dim": 4.868, "$color": "#6CB287" }}
,{ "id": "node295", "name": "S15|RCSL-150 = 5.771m3 ",  "data": { "$area": 5.771, "$dim": 5.771, "$color": "#6CB287" }}
]}
,{ "id": "node350", "name": "RF = 88.632m3 ",  "data": { "$area": 88.632, "$dim": 88.632, "$color": "#6CB287" }
,"children": [
{"id": "node305", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node306", "name": "RB1|RC-500x800 = 3.773m3 ",  "data": { "$area": 3.773, "$dim": 3.773, "$color": "#6CB287" }}
,{ "id": "node307", "name": "RB1|RC-500x800 = 3.773m3 ",  "data": { "$area": 3.773, "$dim": 3.773, "$color": "#6CB287" }}
,{ "id": "node308", "name": "RB1|RC-500x800 = 3.767m3 ",  "data": { "$area": 3.767, "$dim": 3.767, "$color": "#6CB287" }}
,{ "id": "node309", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node310", "name": "RB1|RC-500x800 = 3.773m3 ",  "data": { "$area": 3.773, "$dim": 3.773, "$color": "#6CB287" }}
,{ "id": "node311", "name": "RB1|RC-500x800 = 4.676m3 ",  "data": { "$area": 4.676, "$dim": 4.676, "$color": "#6CB287" }}
,{ "id": "node312", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node313", "name": "RB1|RC-500x800 = 3.773m3 ",  "data": { "$area": 3.773, "$dim": 3.773, "$color": "#6CB287" }}
,{ "id": "node314", "name": "RB1|RC-500x800 = 3.939m3 ",  "data": { "$area": 3.939, "$dim": 3.939, "$color": "#6CB287" }}
,{ "id": "node315", "name": "RB1|RC-500x800 = 3.773m3 ",  "data": { "$area": 3.773, "$dim": 3.773, "$color": "#6CB287" }}
,{ "id": "node316", "name": "RB1|RC-500x800 = 3.773m3 ",  "data": { "$area": 3.773, "$dim": 3.773, "$color": "#6CB287" }}
,{ "id": "node317", "name": "RB1|RC-500x800 = 3.773m3 ",  "data": { "$area": 3.773, "$dim": 3.773, "$color": "#6CB287" }}
,{ "id": "node318", "name": "S15|RCSL-150 = 5.639m3 ",  "data": { "$area": 5.639, "$dim": 5.639, "$color": "#6CB287" }}
,{ "id": "node319", "name": "S15|RCSL-150 = 5.639m3 ",  "data": { "$area": 5.639, "$dim": 5.639, "$color": "#6CB287" }}
,{ "id": "node320", "name": "S15|RCSL-150 = 5.639m3 ",  "data": { "$area": 5.639, "$dim": 5.639, "$color": "#6CB287" }}
,{ "id": "node321", "name": "S15|RCSL-150 = 8.683m3 ",  "data": { "$area": 8.683, "$dim": 8.683, "$color": "#6CB287" }}
,{ "id": "node322", "name": "S15|RCSL-150 = 5.639m3 ",  "data": { "$area": 5.639, "$dim": 5.639, "$color": "#6CB287" }}
,{ "id": "node323", "name": "S15|RCSL-150 = 6.216m3 ",  "data": { "$area": 6.216, "$dim": 6.216, "$color": "#6CB287" }}
]}
]}
]
};
  //var json = {
  //  "id": "node02",
  //  "name": "0.2",
  //  "data": {
  //    "$area": 8,
  //    "$dim": 8,
  //    "$color": "#001eff"
  //  },
  //  "children": [{}]
  //};
  // end //
  // init Icicle
  icicle = new $jit.Icicle({
    // id of the visualization container
    injectInto: 'infovis',
	width: 1200,
	height: 800,
    // whether to add transition animations
    animate: animate,
    // nodes offset
    offset: 1,
    // whether to add cushion type nodes
    cushion: false,
    //show only three levels at a time
    constrained: true,
    levelsToShow: 3,
    // enable tips
    Tips: {
      enable: true,
      type: 'Native',
      // add positioning offsets
      offsetX: 20,
      offsetY: 20,
      // implement the onShow method to
      // add content to the tooltip when a node
      // is hovered
      onShow: function(tip, node){
        // count children
        var count = 0;
        node.eachSubnode(function(){
          count++;
        });
        // add tooltip info
        tip.innerHTML = "<div class=\"tip-title\"><b>Name:</b> " + node.name
            + "</div><div class=\"tip-text\">" + count + " children</div>";
      }
    },
    // Add events to nodes
    Events: {
      enable: true,
      onMouseEnter: function(node) {
        //add border and replot node
        node.setData('border', '#33dddd');
        icicle.fx.plotNode(node, icicle.canvas);
        icicle.labels.plotLabel(icicle.canvas, node, icicle.controller);
      },
      onMouseLeave: function(node) {
        node.removeData('border');
        icicle.fx.plot();
      },
      onClick: function(node){
        if (node) {
          //hide tips and selections
          icicle.tips.hide();
          if(icicle.events.hovered)
            this.onMouseLeave(icicle.events.hovered);
          //perform the enter animation
          icicle.enter(node);
        }
      },
      onRightClick: function(){
        //hide tips and selections
        icicle.tips.hide();
        if(icicle.events.hovered)
          this.onMouseLeave(icicle.events.hovered);
        //perform the out animation
        icicle.out();
      }
    },
    // Add canvas label styling
    Label: {
      type: labelType // "Native" or "HTML"
    },
    // Add the name of the node in the corresponding label
    // This method is called once, on label creation and only for DOM and not
    // Native labels.
    onCreateLabel: function(domElement, node){
      domElement.innerHTML = node.name;
      var style = domElement.style;
      style.fontSize = '0.9em';
      style.display = '';
      style.cursor = 'pointer';
      style.color = '#333';
      style.overflow = 'hidden';
    },
    // Change some label dom properties.
    // This method is called each time a label is plotted.
    onPlaceLabel: function(domElement, node){
      var style = domElement.style,
          width = node.getData('width'),
          height = node.getData('height');
      if(width < 7 || height < 7) {
        style.display = 'none';
      } else {
        style.display = '';
        style.width = width + 'px';
        style.height = height + 'px';
      }
    }
  });
  // load data
  icicle.loadJSON(json);
  // compute positions and plot
  icicle.refresh();
  //end
}

//init controls
function controls() {
  var jit = $jit;
  var gotoparent = jit.id('update');
  jit.util.addEvent(gotoparent, 'click', function() {
    icicle.out();
  });
  var select = jit.id('s-orientation');
  jit.util.addEvent(select, 'change', function () {
    icicle.layout.orientation = select[select.selectedIndex].value;
    icicle.refresh();
  });
  var levelsToShowSelect = jit.id('i-levels-to-show');
  jit.util.addEvent(levelsToShowSelect, 'change', function () {
    var index = levelsToShowSelect.selectedIndex;
    if(index == 0) {
      icicle.config.constrained = false;
    } else {
      icicle.config.constrained = true;
      icicle.config.levelsToShow = index;
    }
    icicle.refresh();
  });
}
//end
