##Solid Quantify v2.51  by TAK2HATA : Copyright 2012.
##ソリッド数量化（著作者TAK2HATA）

####General disclaimer
##I MAKES NO GUARANTEE OF VALIDITY about reports by using this script.
##Please use this script at your own risk.
##免責事項
##このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
##This plugin need sketchup b8 higher.
##Updated in Nov 29,2011:I update this with the proposal by stevendaniels.
######The entity that is in hidden layer is not Quantified in this ver.
##Updated in Mar 16,2012:Improve and add function exporting to XML file.
##Updated in Mar 20,2012:add function exporting to CSV file.add Area of surface and length of Width,Height,Depth.
##Width means lenght of structure element made by Building structure tool.
##Update in Mar 21,2012:Bugfix:Get Component size bug fix.
##Update in Apr 05,2012:version2.0a:Add Estimate cost reporter.and Improve functions.
##Update in Apr 08,2012:version2.0b:Improve and bugfix.
##     "Cost" in Subtotal was incorrect.it fixed.
##     Overrided material by component/group is effective to quantify now.
##     Improve displaying for watcher.
##Update in Apr 10,2012:version2.0c:Add Langauage convert.
##Update in Sep 05,2012:Version2.0d:Bugfix:Surface area calculated double,when that face do not have back-material.
##And mistaked about units when report rendered in webdialog.
##Update in Sep 27,2012:Version2.2:Add Changing Units in report.
##Update in Oct 28,2012:Version2.3:Add option switch of quantifying each component definition.and improve.
##Update in Apr 28,2013:version2.4
##Bugfix about Surface Area in Scaled Component.
##Including area of back_face material.
##Add "Short report/Full report"
##deal with instance name as priority to definition name when the name applied to instance.
##v2.41:Small Improve.When No solid in Model.
##v2.42:
##May 14,2013:Modify filename for useing Sketchup Extension Class.
##v2.4.3:
#####So please remove solid_qunatify2.rb from plugins folder if you already installed older version of this plugin.
##v2.5:
#####Calculate correctly volume of the solid in scaled group.
##日本語：各要素の体積と属性情報をリストにして表示する。スケッチアップv8以上で動作します。
##コスト試算のための単価表の管理も追加しました。
##v2.5.1:
##Dec,15,2013.FIX the errors in solid material changer.

require 'sketchup.rb'
if Sketchup.version.to_f > 14.0
	$kconvloaded = false
else
	begin
		require 'nkf';$kconvloaded = true
	rescue LoadError
		$kconvloaded = false
	end
end


module TAK2HATA::Solid_Quantify2
##################################################

class TAK_SQ2
	def charconv_on_OS( txt = "")
		htmlcode = '<!DOCTYPE html><html><head><meta http-equiv="Content-Type" content="text/html; charset=ANSI" />
		<title>Charset Convert</title>
		</head><body>
		please close if this page keeps showing.</body></html>'
		prfkeys = { 
			:dialog_title => 'Charset Convert', 
			:scrollable => true, 
			:preferences_key => 'Charset Convert', 
			:height => 100, 
			:width => 100, 
			:left => 0, 
			:top => 0, 
			:resizable => false
		} 
		wdlg = UI::WebDialog.new( prfkeys )
		wdlg.set_html( htmlcode )
		wdlg.add_action_callback("send_text"){|d,prm|
			wdlg.close
			p prm
			@conv_filename = prm
		}
		wdlg.show_modal{
			#if txt != ""
				#p txt
				txt.gsub!(/\\/,"/")
				jcmd = 'window.location= "skp:send_text@" + "' + txt + '";'
				#jcmd = 'split_chr("' + txt + '");'
				wdlg.execute_script(jcmd)
			#end
		}
	end
	#char_conv,@conv_filename
	def char_conv( txt = "")
		return "" if txt == nil
		if RUBY_PLATFORM[/darwin/]
			return txt
		else
			if $nkfexist == true
				return NKF.nkf('-Wsx', txt)
			else
				@conv_filename = txt
				charconv_on_OS( txt )
				@conv_filename = txt if not @conv_filename
				return @conv_filename
			end
		end
	end
	def charconv_on_OS( txt )
	htmlcode = '<!DOCTYPE html>
	<html>
		<head>
			<meta http-equiv="Content-Type" content="text/html; charset=ANSI" />
			<title>Charset Convert</title>
		</head>
		<body>
		</body>
	</html>
	'
		prfkeys = { 
			:dialog_title => 'Charset Convert', 
			:scrollable => true, 
			:preferences_key => 'Charset Convert', 
			:height => 100, 
			:width => 100, 
			:left => 0, 
			:top => 0, 
			:resizable => false, 
			:mac_only_use_nswindow => true
		} 

		wdlg = UI::WebDialog.new( prfkeys )
		wdlg.set_html( htmlcode )
		wdlg.add_action_callback("send_text"){|d,prm|
			#p prm
			wdlg.close
			@conv_filename = prm
			#return prm
		}
		wdlg.show_modal{
			txt.gsub!(/\\/,"/")
			#p txt
			jcmd = 'window.location= "skp:send_text@" + "' + txt + '";'
			wdlg.execute_script(jcmd)
		}
	end
	def getVolume( ent , vscale = 1.0 )
		if ent.kind_of? Sketchup::ComponentInstance or ent.kind_of? Sketchup::Group
			return ent.volume * vscale
		else
			return -2.0
		end
	end
	def get_plane_vectors(nvec)
		zvec =  Geom::Vector3d.new(0,0,1)
		if nvec.parallel?( zvec )
			return Geom::Vector3d.new(1,0,0),Geom::Vector3d.new(0,1,0)
		else
			xvec = nvec.cross( zvec ).normalize
			yvec = xvec.cross( nvec ).normalize
			return xvec , yvec
		end
	end
	def getAreaofSurface( ent , mat_area_hash , pmat , tr1 )
		if ent.kind_of? Sketchup::ComponentInstance
			tr= tr1 * ent.transformation
			#xvec = Geom::Vector3d.new( tr.to_a[0],tr.to_a[1],tr.to_a[2] )
			#yvec = Geom::Vector3d.new( tr.to_a[4],tr.to_a[5],tr.to_a[6] )
			#zvec = Geom::Vector3d.new( tr.to_a[8],tr.to_a[9],tr.to_a[10] )
			#sc = xvec.length * yvec.length * zvec.length
			ar = 0.0
			ent.definition.entities.each{|e|
				if e.kind_of? Sketchup::Face
					#v1 = e.normal.cross( e.vertices[0].position.vector_to(e.vertices[1].position) ).normalize.transform( tr )
					#v2 = v1.cross( e.normal ).normalize.transform( tr )
					v1 , v2 = get_plane_vectors( e.normal )
					v1.transform!( tr )
					v2.transform!( tr )
					sc1 = v1.length
					sc2 = v2.length
					ar += e.area * sc1 * sc2
					getArea_byMat e , mat_area_hash , pmat,sc1,sc2
				end
			}
			return ar
		elsif ent.kind_of? Sketchup::Group
			tr= tr1 * ent.transformation
			#xvec = Geom::Vector3d.new( tr.to_a[0],tr.to_a[1],tr.to_a[2] )
			#yvec = Geom::Vector3d.new( tr.to_a[4],tr.to_a[5],tr.to_a[6] )
			#zvec = Geom::Vector3d.new( tr.to_a[8],tr.to_a[9],tr.to_a[10] )
			#sc = xvec.length * yvec.length * zvec.length

			ar = 0.0
			ent.entities.each{|e|
				if e.kind_of? Sketchup::Face
					#v1 = e.normal.cross( e.vertices[0].position.vector_to(e.vertices[1].position) ).normalize.transform( tr )
					#v2 = v1.cross( e.normal ).normalize.transform( tr )
					v1 , v2 = get_plane_vectors( e.normal )
					v1.transform!( tr )
					v2.transform!( tr )
					sc1 = v1.length
					sc2 = v2.length
					ar += e.area * sc1 * sc2
					getArea_byMat e , mat_area_hash , pmat,sc1,sc2
				end
			}
			return ar
		elsif ent.kind_of? Sketchup::Face
			tr = tr1
			#xvec = Geom::Vector3d.new( tr.to_a[0],tr.to_a[1],tr.to_a[2] )
			#yvec = Geom::Vector3d.new( tr.to_a[4],tr.to_a[5],tr.to_a[6] )
			#zvec = Geom::Vector3d.new( tr.to_a[8],tr.to_a[9],tr.to_a[10] )
			#sc = xvec.length * yvec.length * zvec.length
			#v1 = ent.normal.cross( ent.vertices[0].position.vector_to(ent.vertices[1].position) ).normalize.transform( tr )
			#v2 = v1.cross( ent.normal ).normalize.transform( tr )
			v1 , v2 = get_plane_vectors( ent.normal )
			v1.transform!( tr )
			v2.transform!( tr )
			sc1 = v1.length
			sc2 = v2.length
			#ar += e.area * sc1 * sc2
			#p sc
			getArea_byMat ent , mat_area_hash , pmat ,sc1,sc2
		else
			return nil
		end
	end
	def getArea_byMat( ent , mat_area_hash , pmat , sc1 = 1.0 , sc2 = 1.0)
		matname = []
		matname[0] = pmat
		matname[1] = pmat
		if ent.material != nil
			matname[0] = ent.material.name 
		#	matname[1] = pmat
		#else
		#	matname[0] = pmat
		#	matname[1] = ""
		end
		if ent.back_material != nil
			matname[1] = ent.back_material.name
		end
		#matname.uniq!

		matname.find_all{|mn| mn != ""}.each{|mn|
			#p mn
			#p "#{ent.area * sc1 * sc2}<<<#{mn}"
			if mat_area_hash.key?( mn )
				mat_area_hash[ mn ] += ent.area * sc1 * sc2
			else
				mat_area_hash[ mn ] = ent.area * sc1 * sc2
			end
		}
	end
	def getSize( ent )
		if ent.kind_of? Sketchup::ComponentInstance 
			t = ent.transformation
			bb = ent.definition.bounds
			qu = ent.transformation.to_a
			sc = [ qu[0] , qu[5] , qu[10] ]
			ss = [ ( bb.width * sc.x ).abs, ( bb.height * sc.y ).abs , ( bb.depth * sc.z ).abs ]
			return ss
		elsif ent.kind_of? Sketchup::Group
			return [ ( ent.local_bounds.width ).abs , ( ent.local_bounds.height ).abs , ( ent.local_bounds.depth ).abs ]
		else
			return nil
		end
	end
	def getPName( parent )
		pname = ""
		if parent.kind_of? Sketchup::ComponentInstance
			pname = parent.definition.name
			pname = parent.name + "(#{pname})"if parent.name and parent.name != ""
			#pname = parent.definition.name if pname == "" or pname == nil
		elsif parent.kind_of? Sketchup::Group
			pname = parent.name
			pname = "ID:" + parent.entityID.to_s if pname == ""
		elsif parent.kind_of? Sketchup::Model
			pname = ""
		end
		if pname == nil
			pname = "ID:" + parent.entityID.to_s
		end
		return pname
	end
	def getExternalDefinition( dflist , ent , v = 0, sz = [0,0,0] , ar = 0 )
		if ent.kind_of? Sketchup::ComponentInstance
			name = ent.definition.name
			name = ent.name + "(#{name})" if ent.name
		else
			if ent.name and ent.name != ""
				name = "GROUP:" + ent.name
			else
				name = "GROUP:ID" + ent.entityID.to_s
			end
		end
		if dflist.key?( name )
			ent2 , cnt , v2 , sz2 , ar2 = dflist[name]
			v2 =  v2 + v
			ar2 = ar2 + ar
			cnt += 1
			dflist[name] = [ ent2 , cnt , v2 , sz2 , ar2 ]
		else
			dflist[name] = [ ent , 1 , v , sz , ar ]
		end
		#if ent.kind_of? Sketchup::ComponentInstance
		#	if not ent.definition.internal?
		#		velist.push [ ent.definition , tr , path , 0, [0,0,0] , 0 , 1 ]
		#	end
		#end
	end
	def readUnits()
		ssdf = Sketchup.read_default("Solid_Quantify", "units_list")
		if not ssdf
			if Sketchup.active_model.options["UnitsOptions"]["LengthUnit"] < 2
				ssdf = [ "in","sq.in","cu.in","" ].inspect.gsub( 34.chr , "'")
			else
				ssdf = [ "m","m2","m3","" ].inspect.gsub( 34.chr , "'")
			end
		end
		defaults = eval( ssdf )
		@u_len = "m"
		@u_are = "m2"
		@u_vol = "m3"
		@u_cost = ""
		#readUnits()
		@u_len = defaults[0] if defaults[0]
		@u_are = defaults[1] if defaults[1]
		@u_vol = defaults[2] if defaults[2]
		@u_cost = defaults[3] if defaults[3]
	end
	def changeUnits()
		ssdf = Sketchup.read_default("Solid_Quantify", "units_list")
		if not ssdf
			if Sketchup.active_model.options["UnitsOptions"]["LengthUnit"] < 2
				ssdf = [ "in","sq.in","cu.in","" ].inspect.gsub( 34.chr , "'")
			else
				ssdf = [ "m","m2","m3","" ].inspect.gsub( 34.chr , "'")
			end
		end
		defaults = eval( ssdf )
		prompts = [ "LENGTH:" , "AREA:" , "VOLUME:" , "COST:" ]
		list = [ "mm|cm|m|in|ft" , "mm2|cm2|m2|sq.in|sq.ft|sq.yd|" , "mm3|cm3|m3|cu.in|cu.ft|cu.yd" ]
		result = UI.inputbox prompts, defaults, list , "Units For Solid Quantify"
		return if result == nil || result == false
		@u_len = result[0]
		@u_are = result[1]
		@u_vol = result[2]
		@u_cost = result[3]
		Sketchup.write_default("Solid_Quantify", "units_list" , result.inspect.gsub( 34.chr , "'"))
	end
	def searchVolumetrics_json( parent , tr ,json_vol , json_are , json_comp , pmat , dpt )
		#parentがコンポーネントインスタンスの場合はそのdefinitionからentitiesをとる
		if parent.kind_of? Sketchup::ComponentInstance
			pents = parent.definition.entities
		else
			pents = parent.entities
		end
		dflist = Hash.new
		#dflistに体積を持たないコンポの個数量などを保存していく。最後velistに統合する
		mat_area_hash = Hash.new

		pmat2 = pmat
		sum_vols = Hash.new
		sum_ares = Hash.new
		sum_coms = Hash.new
		vsvecx = Geom::Vector3d.new(1.0,0.0,0.0).transform( tr )
		vsvecy = Geom::Vector3d.new(0.0,1.0,0.0).transform( tr )
		vsvecz = Geom::Vector3d.new(0.0,0.0,1.0).transform( tr )
		vscale = vsvecx.length * vsvecy.length * vsvecz.length

		#colorcode = format("%x" , ( rgb[0] / 15 * ( 15 - dpt ) ) * ( 255 ** 2 ) + ( rgb[1] / 15 * ( 15 - dpt )  ) * ( 255 ) + ( rgb[2] / 15 * ( 15 - dpt ) ).to_s
		pents.each{|ent|
			if ent.layer.visible? and ent.visible?
				v = getVolume( ent , vscale )
				#if ent.kind_of? Sketchup::Group
				#	ename = ent.name
				#elsif ent.kind_of? Sketchup::ComponentInstance
				#	ename = ent.definition.name
				#else
				#	ename = ""
				#end
				ename = getPName( ent ) 
				#pmat2 = ent.material.name if ent.material != nil
					if ent.material != nil
						pmat2 = ent.material.name
					else
						pmat2 = pmat
					end
					if v == -2.0
						ar = getAreaofSurface( ent , mat_area_hash , pmat2 , tr )
					elsif v > 0.0
						#体積があるのでコンポかグループであり、さらにその下に他のエンティティは探さなくていい。
						#p "vol"
						ar = getAreaofSurface( ent , mat_area_hash , pmat2 , tr )
						solmat = ent.get_attribute( "BEAM_SPECS","MATERIAL","" )
						solmat = "none" if solmat == ""
						@jnode += 1
						#colorcode = "001eff"
						v2 = sprintf( "%.3f", v * @vscale )
						if json_vol[solmat] != nil
							
							json_vol[ solmat ] = json_vol[ solmat ] + "\n" + ',{ "id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + v2 + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,solmat) + '" }}'
						else
							json_vol[ solmat ] = "\n" + '{"id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + v2.to_s + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,solmat) + '" }}'
						end
						if sum_vols[ solmat ] != nil
							sum_vols[solmat] += v
						else
							sum_vols[solmat] = v
						end
						Sketchup.set_status_text "#{langconv('Searching Solid count')} #{json_vol.size}" if ( json_vol.size % 10 ) == 0
					else
						if ent.kind_of? Sketchup::Group
							getExternalDefinition( dflist , ent )
						else
							#p ent.definition.get_attribute( "SOLID_QUANTIFY" , "ONOFF" )
							if ent.definition.get_attribute( "SOLID_QUANTIFY" , "ONOFF" , false ) == true or ent.definition.hidden? == false
								getExternalDefinition( dflist , ent )
							end
						end

						@jnode += 1
						json_comp2 = Hash.new
						json_vol2 = Hash.new
						json_are2 = Hash.new
						sum_vols2 = Hash.new
						sum_ares2 = Hash.new
						sum_coms2 = Hash.new
						sum_vols2 , sum_ares2 , sum_coms2 = searchVolumetrics_json( ent , tr * ent.transformation , json_vol2 , json_are2 , json_comp2 , pmat , dpt + 1)
						sum_vols2.each{|key,val|
							sum_vols[key] = 0.0 if sum_vols[key] == nil
							sum_vols[key] += val
						}
						sum_ares2.each{|key,val|
							sum_ares[key] = 0.0 if sum_ares[key] == nil
							sum_ares[key] += val
						}
						sum_coms2.each{|key,val|
							sum_coms[key] = 0.0 if sum_coms[key] == nil
							sum_coms[key] += val
						}
						#colorcode = "001eff"
						dpt += 1
						json_vol2.each{|key ,val|
							@jnode += 1
							v2 = sprintf( "%.3f", sum_vols2[key] * @vscale )
							if json_vol[key] != nil
								json_vol[key] = json_vol[key] + "\n" + ',{ "id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + v2 + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
							else
								json_vol[key] = "\n" + '{ "id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + v2 + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
							end
							json_vol[key] = json_vol[key] + "\n" + ',"children": [' + val + "\n" + ']}'
						}
						json_are2.each{|key ,val|
							@jnode += 1
							ar2 = sprintf( "%.3f", sum_ares2[key] * @arscale )
							if json_are[key] != nil
								json_are[key] = json_are[key] + "\n" + ',{ "id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + ar2 + @u_are + ' ",  "data": { "$area": ' + ar2 + ', "$dim": ' + ar2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
							else
								json_are[key] = "\n" + '{ "id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + ar2 + @u_are + ' ",  "data": { "$area": ' + ar2 + ', "$dim": ' + ar2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
							end
							json_are[key] = json_are[key] + "\n" + ',"children": [' + val + "\n" + ']}'
						}
						json_comp2.each{|key ,val|
							@jnode += 1
							cmp2 = sprintf( "%.0f", sum_coms2[key] )
							if json_comp[key] != nil
								json_comp[key] = json_comp[key] + "\n" + ',{ "id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + cmp2 + ' ",  "data": { "$area": ' + cmp2 + ', "$dim": ' + cmp2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
							else
								json_comp[key] = '{ "id": "node' + @jnode.to_s + '", "name": "' + ename + ' = ' + cmp2 +' ",  "data": { "$area": ' + cmp2 + ', "$dim": ' + cmp2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
							end
							json_comp[key] = json_comp[key] + "\n" + ',"children": [' + val + "\n" + ']}'
						}
						dpt = dpt - 1
					end

			end
		}
		
		dflist.each{|name,props|
			ent2 , cnt , v , sz , ar = props
			@jnode += 1
			#colorcode = "001eff"
			if json_comp[name] != nil
				json_comp[name] = json_comp[name] + "\n" + ',{"id": "node' + @jnode.to_s + '", "name": "' + name + ' = ' + cnt.to_s + ' ",  "data": { "$area": ' + cnt.to_s + ', "$dim": ' + cnt.to_s + ', "$color": "#' + get_colorcode( dpt ,name) + '" }}'
			else
				json_comp[name] = "\n" + '{"id": "node' + @jnode.to_s + '", "name": "' + name + ' = ' + cnt.to_s + ' ",  "data": { "$area": ' + cnt.to_s + ', "$dim": ' + cnt.to_s + ', "$color": "#' + get_colorcode( dpt ,name) + '" }}'
			end
			if sum_coms[name] != nil
				sum_coms[name] += cnt
			else
				sum_coms[name] = cnt
			end
		}
		mat_area_hash.each{|name,ar|
			@jnode += 1
			#colorcode = "001eff"
			ar2 = sprintf( "%.3f", ar * @arscale )
			#if name != "" and @area_mats.index(name) == nil then @area_mats.push name
			if json_are[name] != nil
				json_are[name] = json_are[name] + "\n" + ',{"id": "node' + @jnode.to_s + '", "name": "' + name + ' = ' + ar2 + @u_are + ' ",  "data": { "$area": ' + ar2 + ', "$dim": ' + ar2 + ', "$color": "#' + get_colorcode( dpt ,name) + '" }}'
			else
				json_are[name] = "\n" + '{"id": "node' + @jnode.to_s + '", "name": "' + name + ' = ' + ar2 + @u_are + ' ",  "data": { "$area": ' + ar2 + ', "$dim": ' + ar2 + ', "$color": "#' + get_colorcode( dpt ,name) + '" }}'
			end
			if sum_ares[name] != nil
				sum_ares[name] += ar
			else
				sum_ares[name] = ar
			end
		}
		return sum_vols , sum_ares , sum_coms
	end
	def get_colorcode( dpt , name )
		mats = Sketchup.active_model.materials
		@colorcode = Hash.new if @colorcode == nil
		if @colorcode[name] == nil
			if mats[name] == nil
				@colorcode[name] = [ (rand(110)+100),(rand(100)+100),(rand(100)+100)]
			else
				mat = mats[name]
				@colorcode[name] = [ mat.color.red , mat.color.green , mat.color.blue ]
			end
			#p @colorcode[name]
		end
		if dpt <= 10.0
			dpt2 = 1.0 - dpt.to_f / 10.0
		else
			dpt2 = 0.0
		end
		@colorcode[name].map!{|i|
			if i > 200
				i = 200
			else
				i
			end
		}
		rgb = @colorcode[name].map{|i| format( "%02x" , ( i.to_f * dpt2 ).to_i )}
		return rgb.join.upcase
	end
	def searchVolumetrics( velist , parent , tr , path , matlist = [] , pmat = "" )
		#parentがコンポーネントインスタンスの場合はそのdefinitionからentitiesをとる
		if parent.kind_of? Sketchup::ComponentInstance
			pents = parent.definition.entities
		else
			pents = parent.entities
		end
		dflist = Hash.new
		#dflistに体積を持たないコンポの個数量などを保存していく。最後velistに統合する
		mat_area_hash = Hash.new
		path = path + getPName( parent ) + "//"
		pmat2 = pmat
		vsvecx = Geom::Vector3d.new(1.0,0.0,0.0).transform( tr )
		vsvecy = Geom::Vector3d.new(0.0,1.0,0.0).transform( tr )
		vsvecz = Geom::Vector3d.new(0.0,0.0,1.0).transform( tr )
		vscale = vsvecx.length * vsvecy.length * vsvecz.length
		pents.each{|ent|
			if ent.layer.visible? and ent.visible?
				v = getVolume( ent ,vscale )
				#if ent.kind_of? Sketchup::Group
				#	ename = ent.name
				#elsif ent.kind_of? Sketchup::ComponentInstance
				#	ename = ent.definition.name
				#else
				#	ename = ""
				#end
				ename = getPName( ent ) 
				#pmat2 = ent.material.name if ent.material != nil
					if ent.material != nil
						pmat2 = ent.material.name
					else
						pmat2 = pmat
					end
					if v == -2.0
						#p "nil"
						#This is not Instance or Group
						#コンポーネントやグループ以外のとき
						#if to_json == false
							ar = getAreaofSurface( ent , mat_area_hash , pmat2 , tr )
						#else
						#end
					elsif v > 0.0
						#体積があるのでコンポかグループであり、さらにその下に他のエンティティは探さなくていい。
						#p "vol"

						#solmat = ent.get_attribute( "BEAM_SPECS","MATERIAL","" )
						#if solmat != "" and @sol_mats.index( solmat ) == nil then @sol_mats.push solmat

						ar = getAreaofSurface( ent , mat_area_hash , pmat2 , tr )
						sz = getSize( ent )
						#p "#{tr} * #{ent.transformation.inverse}"
						if ent.kind_of? Sketchup::Group
							velist.push [ ent , ( tr * ent.transformation  ) , path , v , sz , ar , 1 ]
						elsif Sketchup::ComponentInstance
							if ent.definition.get_attribute( "SOLID_QUANTIFY" , "ONOFF" , false ) == true or ent.definition.hidden? == false
								getExternalDefinition( dflist , ent , v , sz , ar )
							end
						end
						
						Sketchup.set_status_text "#{langconv('Searching Solid count')} #{velist.size}" if ( velist.size % 10 ) == 0
					else
						#体積が無いのでコンポかグループだけど、その下にあるエンティティも探索対象になる
						#p "else"
						#This is Ins or Group but no volume
						#if to_json == false
							if ent.kind_of? Sketchup::Group
								getExternalDefinition( dflist , ent )
							else
								#p ent.definition.get_attribute( "SOLID_QUANTIFY" , "ONOFF" )
								if ent.definition.get_attribute( "SOLID_QUANTIFY" , "ONOFF" , false ) == true or ent.definition.hidden? == false
									getExternalDefinition( dflist , ent )
								end
							end
							#if ent.definition.group? or ent.definition.internal? != true
						#else
							
						#end
						searchVolumetrics( velist , ent , tr * ent.transformation , path , matlist , pmat )
					end

			end
		}
		dflist.each{|name,props|
			ent2 , cnt , v , sz , ar = props
			velist.push [ ent2 , tr , path , v , sz , ar , cnt ]
		}
		mat_area_hash.each{|name,ar|
			#p name
			#if name != "" and @area_mats.index(name) == nil then @area_mats.push name
			matlist.push [ path , name , ar ]
		}
	end
	def solid_quantifycation_json( to_vol = true)
	    model = Sketchup.active_model
	    ents = model.entities
	    sels = model.selection
		#result = UI.messagebox "[YES6] to XML <-> [NO7] to CSV [CANCEL]to Display now.", MB_YESNOCANCEL 
		myname = char_conv( __FILE__ )
		mydir = File::dirname( myname )
		
		readUnits()
		@lscale = 1.0 #inch
		case @u_len
		when "mm"
			@lscale = 25.4
		when "cm"
			@lscale = 2.54
		when "m"
			@lscale = 0.0254
		when "ft"
			@lscale = 0.083332
		when "yd"
			@lscale = 0.027777
		end
		@arscale = 1.0 #inch
		case @u_are
		when "mm2"
			@arscale = 25.4 ** 2
		when "cm2"
			@arscale = 2.54 ** 2
		when "m2"
			@arscale = 0.0254 ** 2
		when "sq.ft"
			@arscale = 0.083332 ** 2
		when "sq.yd"
			@arscale = 0.027777 ** 2
		end
		@vscale = 1.0 #inch
		case @u_vol
		when "mm3"
			@vscale = 25.4 ** 3
		when "cm3"
			@vscale = 2.54 ** 3
		when "m3"
			@vscale = 0.0254 ** 3
		when "cu.ft"
			@vscale = 0.083332 ** 3
		when "cu.yd"
			@vscale = 0.027777 ** 3
		end
		json_vol = Hash.new
		json_are = Hash.new
		json_comp = Hash.new
		sum_vols = Hash.new
		sum_ares = Hash.new
		sum_coms = Hash.new
		@jnode = 0
		dpt = 0
		#rgb = [ ( rand( 210 ) + 50) , ( rand( 210 ) + 50),( rand( 210 ) + 50) ]
		sum_vols , sum_ares , sum_coms = searchVolumetrics_json( model , Geom::Transformation.new( [0,0,0] ) , json_vol , json_are , json_comp , "" , dpt)
		json_volcode = ""
		
		#colorcode = format("%x" , ( rgb[0] / 15 * ( 15 - dpt ) ) * ( 255 ** 2 ) + ( rgb[1] / 15 * ( 15 - dpt )  ) * ( 255 ) + ( rgb[2] / 15 * ( 15 - dpt ) ).to_s

		tvol = 0.0
		json_vol.each{|key ,val|
			@jnode += 1
			tvol = tvol + sum_vols[key]
			v2 = sprintf( "%.3f", sum_vols[key] * @vscale )
			if json_volcode != ""
				json_volcode = json_volcode + "\n" + ',{ "id": "node' + @jnode.to_s + '", "name": "' + key + ' = ' + v2 + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
			else
				json_volcode = '{ "id": "node' + @jnode.to_s + '", "name": "' + key + ' = ' + v2 + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
			end
			json_volcode = json_volcode + "\n" + ',"children": [' + val + "\n" + ']}'
		}
		v2 = sprintf( "%.3f", tvol * @vscale )
		@jnode += 1
		tcode = '{ "id": "node' + @jnode.to_s + '", "name": "TOTAL:' + v2 + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,"TOTAL") + '" }'
		json_volcode = tcode + ',"children":[' + json_volcode + "\n]\n}"
		
		json_arecode = ""
		tare = 0.0
		json_are.each{|key ,val|
			@jnode += 1
			v2 = sprintf( "%.3f", sum_ares[key] * @arscale )
			tare = tare + sum_ares[key]
			if json_arecode != ""
				json_arecode = json_arecode + "\n" + ',{ "id": "node' + @jnode.to_s + '", "name": "' + key + ' = ' + v2 + @u_are + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
			else
				json_arecode= '{ "id": "node' + @jnode.to_s + '", "name": "' + key + ' = ' + v2 + @u_are + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,key) + '" }'
			end
			json_arecode = json_arecode + "\n" + ',"children": [' + val + "\n" + ']}'
		}

		v2 = sprintf( "%.3f", tare * @arscale )
		@jnode += 1
		tcode = '{ "id": "node' + @jnode.to_s + '", "name": "TOTAL:' + v2 + @u_vol + ' ",  "data": { "$area": ' + v2 + ', "$dim": ' + v2 + ', "$color": "#' + get_colorcode( dpt ,"TOTAL") + '" }'
		json_arecode = tcode + ',"children":[' + json_arecode + "\n]\n}"

		
		
		base_file_path = File.join( mydir , "js", "base_js.js" )
		export_file_path = File.join( mydir , "js" , "chartdata.js" )
		file=File.new(base_file_path,"r")
		tbuff = file.read
		file.close
		if to_vol == true
			tbuff.sub!( "// init data //",json_volcode)
		else
			tbuff.sub!( "// init data //",json_arecode)
		end
		file=File.new(export_file_path,"w+")
		file.puts tbuff
		file.close
		wdlg_path = File.join( mydir , "webdialog.html" )
		UI.openURL wdlg_path
		return
		
		mdlg = UI::WebDialog.new( "SOLID QUANTIFY CHART", true, "SOLID_QUANTIFY_CHART", 800, 800, 150, 150, true )
		mdlg.set_file( wdlg_path )

		if RUBY_PLATFORM[/darwin/]
			mdlg.show_modal { }
		else
			mdlg.show { }
		end		
	end
	def solid_quantification( result )
	    #Sketchup.active_model.start_operation "Solid Quantification",true
	    #Get the current selection 
	    model = Sketchup.active_model
	    ents = model.entities
	    sels = model.selection
		#result = UI.messagebox "[YES6] to XML <-> [NO7] to CSV [CANCEL]to Display now.", MB_YESNOCANCEL 
		myname = Sketchup.active_model.path
		mydir = File::dirname( myname )
		if result == 6 # Yes
			if myname == ""
				myname = "*.quant.xml"
			else
				myname = File::basename( myname , ".*") + ".quant.xml"
			end
			save_filename = UI.savepanel "#{langconv('Save XML File')}", mydir, myname
			return if save_filename == nil
			save_filename = char_conv(save_filename)
			#charconv_on_OS(save_filename)
			#save_filename = @filename
		elsif result == 7 # NO
			if myname == ""
				myname = "*.quant.csv"
			else
				myname = File::basename( myname , ".*") + ".quant.csv"
			end
			save_filename = UI.savepanel "#{langconv('Save CSV File')}", mydir, myname
			return if save_filename == nil
			save_filename = char_conv(save_filename)
			#charconv_on_OS(save_filename)
			#save_filename = @filename
		end
		
	    #sectionlist = sels.find_all{|e| e.get_attribute("SECTION_SPECS","GROUP") != nil }
	    #rad = model.bounds.diagonal * 2.0
	    
		
		#cen = model.bounds.center

	    #Searching for Solids
		velist = [] #list of volume element
		matlist = []
		path = ""
		

		searchVolumetrics( velist ,  model , Geom::Transformation.new( [0,0,0] ) , path , matlist)
		#velist = searchVolumetrics2()

		#if velist.size == 0
		#	UI.messagebox "No volumes!"
		#	return
		#end
		csvlist = []
		elehash = Hash.new
		#chk_imperial = false
		#chk_imperial = true if Sketchup.active_model.options["UnitsOptions"]["LengthUnit"] < 2
		readUnits()
		lscale = 1.0 #inch
		case @u_len
		when "mm"
			lscale = 25.4
		when "cm"
			lscale = 2.54
		when "m"
			lscale = 0.0254
		when "ft"
			lscale = 0.083332
		when "yd"
			lscale = 0.027777
		end
		arscale = 1.0 #inch
		case @u_are
		when "mm2"
			arscale = 25.4 ** 2
		when "cm2"
			arscale = 2.54 ** 2
		when "m2"
			arscale = 0.0254 ** 2
		when "sq.ft"
			arscale = 0.083332 ** 2
		when "sq.yd"
			arscale = 0.027777 ** 2
		end
		vscale = 1.0 #inch
		case @u_vol
		when "mm3"
			vscale = 25.4 ** 3
		when "cm3"
			vscale = 2.54 ** 3
		when "m3"
			vscale = 0.0254 ** 3
		when "cu.ft"
			vscale = 0.083332 ** 3
		when "cu.yd"
			vscale = 0.027777 ** 3
		end
		#@u_len
		#@u_are
		#@u_vol
		
		
		velist.each{| ve , tr, path , vol , siz , are , cnt |
			name = ""
			name = getPName( ve )

			eID = ve.entityID.to_s
			elehash[eID] = ve
			#parentname = ""
			
			vstr = sprintf( "%.3f", vol * vscale )
			arstr = sprintf( "%.3f", are * arscale )
			xstr = sprintf( "%.3f", siz[0] * lscale )
			ystr = sprintf( "%.3f", siz[1] * lscale  )
			zstr = sprintf( "%.3f", siz[2] * lscale  )

			bclass = ve.get_attribute( "BEAM_SPECS","CLASS","" )
			btag = ve.get_attribute( "BEAM_SPECS","HUGO","" )
			bprofile = ve.get_attribute( "BEAM_SPECS","PROFILE","" )
			bmat = ve.get_attribute( "BEAM_SPECS","MATERIAL","" )
			if vol > 0.0 and bmat == ""
				bmat = "none"
			end
			if bclass == "" and ve.kind_of? Sketchup::ComponentInstance
				bclass = "#{langconv('COMPONENTINSTANCE')}"
			end


				#if chk_imperial
				#	csvlist.push [ path , bmat , bclass , name , btag , bprofile , eID , custr , sqstr , xistr , yistr , zistr , cnt.to_s ]
				#else
				csvlist.push [ path , bmat , bclass , name , btag , bprofile , eID , vstr , arstr , xstr , ystr , zstr , cnt.to_s ]
				#end
				#end

		}


		matlist.each{| path , aname , are |
			mname = aname.gsub(/\</,"&lt;")
			mname.gsub!(/\>/,"&gt;")
			arstr = sprintf( "%.3f", are * arscale )

			#sqstr = sprintf( "%.3f", are )
			#if chk_imperial
			#	csvlist.push [ path , "" , "#{langconv('SURFACE_MATERIAL')}" , "#{langconv('SU_MAT')}::" + mname , "" , "" , "" , "0" , sqstr , "0" , "0" , "0" , "0" ]
			#else
				csvlist.push [ path ,"" , "#{langconv('SURFACE_MATERIAL')}" , "#{langconv('SU_MAT')}::" + mname , "" , "" , "" , "0" , arstr , "0" , "0" , "0" , "0" ]
			#end

		}
		x = 0

			csvlist2 = csvlist.sort_by{|v| [ v[0] , v[1] , v[2] , x += 1] }
			if result == 6 # Yes
				export_with_xml( csvlist2 , save_filename , "XML" )
			elsif result == 7 # No
				export_with_xml( csvlist2 , save_filename , "CSV" )
				#export_with_csv( csvlist2 , save_filename , chk_imperial )
			elsif result == 1
				export_with_xml( csvlist2 , save_filename , "SHORT" )
			else
				export_with_xml( csvlist2 , save_filename , "HTML" )
				#display_with_html( csvlist2 ,sels , chk_imperial )
			end

	end

	def export_with_xml( csvlist2 , save_filename , ftype = "XML" )
		
		if ftype == "XML"
			savefile = File.expand_path(save_filename)
			#savefile = savefile + ".quant.xml" if File.extname(savefile).upcase != ".XML"
			#savefile.gsub!(/\//,'\\')
			savefile = File.expand_path(save_filename)
			savefile = chk_extname( savefile , ".quant.xml" )
			savefile.gsub!(/\//,'\\')
		elsif ftype == "CSV"
			savefile = File.expand_path(save_filename)
			#savefile = savefile + ".csv" if File.extname(savefile).upcase != ".CSV"
			#savefile.gsub!(/\//,'\\')
			savefile = File.expand_path(save_filename)
			savefile = chk_extname( savefile , ".quant.csv" )
			savefile.gsub!(/\//,'\\')
		elsif ftype == "HTML" or ftype == "SHORT"
		end

		materiallist , dfnamelist = getpricinglist
		#p savefile
		if csvlist2 == []
			UI.messagebox "No Entities!"
			return
		end
		ppname = csvlist2[0][2]
		ppmat = csvlist2[0][1]
		pvol = 0.0
		parea = 0.0
		pwidth = 0.0
		pheight = 0.0
		pdepth = 0.0
		pcost = 0.0
		pcnt = 0
		totalcost = 0.0
		volhash = Hash.new
		dfhash = Hash.new
		mthash = Hash.new
		cuhash = Hash.new
		cr = "\n"

		if ftype == "XML"
			shtm = xmlss_header()
			shtm << xmlss_styles()
			shtm << xmlss_worksheet_start("#{langconv('SOLID_QUANTIFY')}" )
		elsif ftype == "CSV"
			shtm = "#{langconv('PARENTNAME')},#{langconv('NAME')},#{langconv('SOLID MATERIAL')},"
			shtm << "#{langconv('CLASS')},#{langconv('TAG')},#{langconv('PROFILE')},#{langconv('COUNT(PC)')},"
			shtm << "#{langconv('VOLUME')}(" + @u_vol + "),"
			shtm << "#{langconv('AREA')}(" + @u_are + "),"
			shtm << "#{langconv('LENGTH(WIDTH)')}(" + @u_len + "),"
			shtm << "#{langconv('HEIGHT')}(" + @u_len + "),"
			shtm << "#{langconv('DEPTH')}(" + @u_len + "),#{langconv('COST')}(" + @u_cost + ")" + cr
		elsif ftype == "HTML" or ftype == "SHORT"
			shtm = html_header()
		end
		#sprintf( "%.3f", pvol)
		csvlist2.each{| parentname , bmat , bclass , name , btag , bprofile , eID , vstr , arstr , xstr , ystr , zstr , cntstr |
			if bclass == langconv("COMPONENTINSTANCE")
				allcnt = dfhash[ name ]
				if dfhash.key?( name )
					dfhash[ name ] += cntstr.to_f
				else
					dfhash[ name ] = cntstr.to_f
				end
			elsif bclass == langconv("SURFACE_MATERIAL")
				#allcnt = dfhash[ name ]
				if mthash.key?( name )
					mthash[ name ] += arstr.to_f
				else
					mthash[ name ] = arstr.to_f
				end
			else
			end
			if ppname != parentname or ppmat != bmat
				if pvol > 0.0 and ppmat != "" then
					if ftype == "XML"
						shtm << xmlss_subtotal( ppname , ppmat , pvol , parea , pwidth , pheight , pdepth , pcost )
					elsif ftype == "CSV"
						#shtm << "#{ppname},#{ppmat} SUBTOTAL,,,,,"
						#shtm << "0,#{sprintf( '%.3f', pvol )},#{sprintf( '%.3f', parea )},"
						#shtm << "#{sprintf( '%.3f', pwidth )},#{sprintf( '%.3f', pheight )},#{sprintf( '%.3f', pdepth )},#{sprintf( '%.3f', pcost )}" + cr
					elsif ftype == "HTML"
						shtm << html_subtotal( ppname , ppmat , pvol , parea , pwidth , pheight , pdepth , pcost )
					end
				end
				ppname = parentname
				pvol = 0.0
				parea = 0.0
				pwidth = 0.0
				pheight = 0.0
				pdepth = 0.0
				pcost = 0.0
				pcnt = 0
				#pcu = 0.0
				ppmat = bmat
			end
			if volhash.key?( bmat )
				vol , area , width , height , depth = volhash[ bmat ]
				vol += vstr.to_f
				area += arstr.to_f
				width += xstr.to_f
				height += ystr.to_f
				depth += zstr.to_f
				volhash[ bmat ] = [ vol , area , width , height , depth ]
				#volhash[ bmat ] += vstr.to_f
				#cuhash[ bmat ] += custr.to_f
			else
				vol = vstr.to_f
				area = arstr.to_f
				width = xstr.to_f
				height = ystr.to_f
				depth = zstr.to_f
				volhash[ bmat ] = [ vol , area , width , height , depth ]
				#volhash[ bmat ] = vstr.to_f
				#cuhash[ bmat ] = custr.to_f
			end
			parentname = "" if parentname == ""
			name = "" if name == ""
			bmat = "" if bmat == ""
			bclass = "" if bclass == ""
			btag = "" if btag == ""
			bprofile = "" if bprofile == ""
			pvol += vstr.to_f
			parea += arstr.to_f
			pwidth += xstr.to_f
			pheight += ystr.to_f
			pdepth += zstr.to_f
			pcnt = cntstr.to_f
			cost = 0.0
			if bclass == langconv("COMPONENTINSTANCE") and dfnamelist.key?( name ) == true
				pc , vc , ac , wc , hc , dc = array2eval( dfnamelist[ name ] )
				#pcost += ( pcnt * pc )
				cost = ( cntstr.to_f * pc )
				pcost += cost
			elsif bclass == langconv("SURFACE_MATERIAL") and dfnamelist.key?( name ) == true
				pc , vc , ac , wc , hc , dc = array2eval( dfnamelist[ name ] )
				#pcost += ( parea * ac )
				cost = ( arstr.to_f * ac )
				pcost += cost
			elsif bmat != nil and bmat != "" and materiallist.key?( bmat ) == true
				pc , vc , ac , wc , hc , dc = array2eval( materiallist[ bmat ] )
				#pcost += ( pvol * vc ) + ( parea * ac ) + ( pwidth * wc ) + ( pheight * hc ) + ( pdepth * dc )
				cost = ( vstr.to_f * vc ) + ( arstr.to_f * ac ) + ( xstr.to_f * wc ) + ( ystr.to_f * hc ) + ( zstr.to_f * dc )
				pcost += cost
			end
			#pcu = pcu + custr.to_f
			if ftype == "XML"
				shtm << xmlss_row( parentname , name , bmat , bclass , btag , bprofile , cntstr , vstr , arstr , xstr , ystr , zstr , cost )
			elsif ftype == "CSV"
				parentname2 = parentname.gsub(/\&lt\;/,"<").gsub(/\&gt\;/,">")
				name2 = name.gsub(/\&lt\;/,"<").gsub(/\&gt\;/,">")
				shtm <<	"#{parentname2},#{name2},#{bmat},#{bclass},#{btag},#{bprofile},#{cntstr},#{vstr},#{arstr},#{xstr},#{ystr},#{zstr},#{cost}" + cr
			elsif ftype == "HTML"
				shtm << html_row( parentname , name , bmat , bclass , btag , bprofile , cntstr , vstr , arstr , xstr , ystr , zstr , cost , eID )
			end
		}
		if pvol > 0.0 and ppmat != "" then
			if ftype == "XML"
				shtm << xmlss_subtotal( ppname , ppmat , pvol , parea , pwidth , pheight , pdepth , pcost )
			elsif ftype == "CSV"
				#shtm << "#{ppname},#{ppmat} SUBTOTAL,,,,,"
				#shtm << "0,#{sprintf( '%.3f', pvol )},#{sprintf( '%.3f', parea )},"
				#shtm << "#{sprintf( '%.3f', pwidth )},#{sprintf( '%.3f', pheight )},#{sprintf( '%.3f', pdepth )},#{sprintf( '%.3f', pcost )}" + cr
			elsif ftype == "HTML"
				shtm << html_subtotal( ppname , ppmat , pvol , parea , pwidth , pheight , pdepth , pcost )
			end
		end
		totalacross = 0
		if ftype == "XML"
			shtm << '<Row ss:StyleID="black_white"><Cell><Data ss:Type="String">' + langconv("SOLID MATERIAL TOTALS") + ' </Data></Cell></Row>'
		elsif ftype == "CSV"
			shtm <<  langconv("SOLID MATERIAL TOTALS") + cr
		elsif ftype == "HTML" or ftype == "SHORT"
			shtm << "<tr bgcolor = '#000000' ><td colspan = '13' ><FONT COLOR='#FFFFFF'>" + langconv("SOLID MATERIAL TOTALS") + "</FONT></td></tr>"
		end

		totalacross += -1
		volhash.each{|mat , props |
			cost = 0.0
			vol , area , width , height , depth = props
			if mat != "" and vol.to_f > 0.0
				if mat != nil and mat != "" and materiallist.key?( mat ) == true
					pc , vc , ac , wc , hc , dc = array2eval( materiallist[ mat ] )
					cost = ( vol.to_f * vc ) + ( area.to_f * ac ) + ( width.to_f * wc ) + ( height.to_f * hc ) + ( depth.to_f * dc )
				end
				#cu = cuhash[mat]
				totalcost += cost
				if ftype == "XML"
					shtm << xmlss_total( langconv('SOLID MATERIAL') + ':"' + mat + '"' , vol , area , width , height , depth , cost , 0 )
				elsif ftype == "CSV"
					mat2 = mat.gsub(/\&lt\;/,"<").gsub(/\&gt\;/,">")
					shtm << "SOLID MATERIAL: #{mat2} TOTAL,,,,,,"
					shtm << "#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', vol )},#{sprintf( '%.3f', area )},"
					shtm << "#{sprintf( '%.3f', width )},#{sprintf( '%.3f', height )},#{sprintf( '%.3f', depth )},#{sprintf( '%.3f', cost )}" + cr
				elsif ftype == "HTML" or ftype == "SHORT"
					shtm << html_total( langconv('SOLID MATERIAL') + ':"' + mat + '"' , vol , area , width , height , depth , cost , 0 )
				end
			end
			totalacross += -1
		}
		if ftype == "XML"
			shtm << '<Row ss:StyleID="black_white"><Cell><Data ss:Type="String">' + langconv('COMPONENT TOTALS') + '</Data></Cell></Row>'
		elsif ftype == "CSV"
			shtm << langconv('COMPONENT TOTALS') + cr
		elsif ftype == "HTML" or ftype == "SHORT"
			shtm << "<tr bgcolor = '#000000' ><td colspan = '13' ><FONT COLOR='#FFFFFF'>" + langconv('COMPONENT TOTALS') + "</FONT></td></tr>"
		end

		totalacross += -1
		dfhash.sort_by{|key , val| key }.each{|name , props |
			cost = 0.0
			cnt = props
			if name != nil and name != "" and dfnamelist.key?( name ) == true
				pc , vc , ac , wc , hc , dc = array2eval( dfnamelist[ name ] )
				cost = ( cnt.to_f * pc )
			end
			totalcost += cost
			#cu = cuhash[mat]
			if ftype == "XML"
				shtm << xmlss_total( langconv('COMPONENT') + ':"' + name + '"' , 0 , 0 , 0 , 0 , 0 , cost , cnt )
			elsif ftype == "CSV"
				shtm << langconv('COMPONENT') + ": #{name} " + langconv("TOTALS") + ",,,,,,"
				shtm << "#{sprintf( '%.3f', cnt )},#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', 0 )},"
				shtm << "#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', cost )}" + cr
			elsif ftype == "HTML" or ftype == "SHORT"
				shtm << html_total( langconv('COMPONENT') + ':"' + name + '"' , 0 , 0 , 0 , 0 , 0 , cost , cnt )
			end
			
			totalacross += -1
		}
		if ftype == "XML"
			shtm << '<Row ss:StyleID="black_white"><Cell><Data ss:Type="String">' + langconv('SURFACE_MATERIAL TOTALS') + '</Data></Cell></Row>'
		elsif ftype == "CSV"
			shtm << langconv('SURFACE_MATERIAL TOTALS') + cr
		elsif ftype == "HTML" or ftype == "SHORT"
			shtm << "<tr bgcolor = '#000000' ><td colspan = '13' ><FONT COLOR='#FFFFFF'>" + langconv('SURFACE_MATERIAL TOTALS') + "</FONT></td></tr>"
		end
		totalacross += -1
		mthash.sort_by{|key , val| key }.each{|name , area |
			cost = 0.0
			if name != nil and name != "" and dfnamelist.key?( name ) == true
				pc , vc , ac , wc , hc , dc = array2eval( dfnamelist[ name ] )
				cost = ( area.to_f * ac )
			end
			totalcost += cost
			#cu = cuhash[mat]
			if ftype == "XML"
				shtm << xmlss_total( name , 0 , area , 0 , 0 , 0 , cost , 0 )
			elsif ftype == "CSV"
				name2 = name.gsub(/\&lt\;/,"<").gsub(/\&gt\;/,">")
				shtm << "#{name2} #{langconv('TOTAL')},,,,,,"
				shtm << "#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', area )},"
				shtm << "#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', 0 )},#{sprintf( '%.3f', cost )}" + cr
			elsif ftype == "HTML" or ftype == "SHORT"
				shtm << html_total( name , 0 , area , 0 , 0 , 0 , cost , 0 )
			end
			
			totalacross += -1
		}
		if ftype == "XML"
			shtm << xmlss_totaltotal( totalacross )
			shtm << xmlss_worksheet_end()
			shtm << xmlss_footer()
			xf = File.new(savefile, "w")
			Sketchup.set_status_text langconv("exporting to") + ":" + savefile
			xf.puts shtm
			xf.close
		elsif ftype == "CSV"
			shtm << "#{langconv('TOTAL TOTAL')},,,,,,"
			shtm << ",,,"
			shtm << ",,,#{sprintf( '%.3f', totalcost )}" + cr
			xf = File.new(savefile, "w")
			Sketchup.set_status_text langconv("exporting to") + ":" + savefile
			xf.puts shtm
			xf.close
		elsif ftype == "HTML" or ftype == "SHORT"
			shtm << html_totaltotal( totalacross , totalcost )
			shtm << "</table></body></html>"
			mdlg = UI::WebDialog.new( "SOLID QUANTIFY", true, "SOLID_QUANTIFY", 800, 800, 150, 150, true )
			mdlg.set_html( shtm )

			if RUBY_PLATFORM[/darwin/]
				mdlg.show_modal { }
			else
				mdlg.show { }
			end
		end

		Sketchup.set_status_text langconv("Finished")
	end

	def export_unitpricing_list(result=6)

	    model = Sketchup.active_model
	    ents = model.entities
	    sels = model.selection
		save_filename = ""
		myname = Sketchup.active_model.path
		mydir = File::dirname( myname )

		if result == 6 # Yes
			if myname == ""
				myname = "*.price.xml"
			else
				myname = File::basename( myname , ".*") + ".price.xml"
			end
			save_filename = UI.savepanel langconv("Save units pricing as XML File"), mydir, myname
			return if save_filename == nil
			if File.exists?( save_filename )
			else
				save_filename = char_conv(save_filename)
				#charconv_on_OS(save_filename)
				#save_filename = @filename
			end
			savefile = File.expand_path(save_filename)
			#savefile = savefile + ".price.xml" if File.extname(savefile).upcase != ".XML"
			savefile = chk_extname( savefile , ".price.xml" )
			savefile.gsub!(/\//,'\\')
		elsif result == 7 # NO
			if myname == ""
				myname = "*.price.csv"
			else
				myname = File::basename( myname , ".*") + ".price.csv"
			end
			save_filename = UI.savepanel langconv("Save units pricing as CSV File"), mydir, myname
			return if save_filename == nil
			if File.exists?( save_filename )
			else
				save_filename = char_conv(save_filename)
				#charconv_on_OS(save_filename)
				#save_filename = @filename
			end
			savefile = File.expand_path(save_filename)
			savefile = chk_extname( savefile , ".price.csv" )
			savefile.gsub!(/\//,'\\')
		end
		
	    #Searching for Solids
		velist = [] #list of volume element
		matlist = []
		materiallist , dfnamelist = getpricinglist

		path = ""
		searchVolumetrics( velist ,  model , Geom::Transformation.new( [0,0,0] ) , path , matlist )

		elehash = Hash.new
		#chk_imperial = false
		#chk_imperial = true if Sketchup.active_model.options["UnitsOptions"]["LengthUnit"] < 2

		pc,vol,ar,w,h,d = 0,0,0,0,0,0
		mat = ""

		velist.each{| ve , tr, parent , vol2 , siz , are |
			bclass = ve.get_attribute( "BEAM_SPECS","CLASS","" )
			btag = ve.get_attribute( "BEAM_SPECS","HUGO","" )
			bprofile = ve.get_attribute( "BEAM_SPECS","PROFILE","" )
			bmat = ve.get_attribute( "BEAM_SPECS","MATERIAL","none" )
			
			if bmat == "" and ve.kind_of? Sketchup::ComponentInstance
				dfname = ve.definition.name
				if dfnamelist == nil or dfnamelist.key?(dfname) == false
					dfnamelist[ dfname ] = [ pc,vol,ar,w,h,d ]
				end
			end
			if materiallist == nil or materiallist.key?( bmat) == false
				materiallist[ bmat ] = [ pc,vol,ar,w,h,d ]
			end

		}
		matlist.each{| path , aname , are |
			mname = aname.gsub(/\</,"&lt;")
			mname.gsub!(/\>/,"&gt;")
			dfnamelist[ "#{langconv('SU_MAT')}::" + mname ] = [ pc,vol,ar,w,h,d ]
		}
		model.definitions.each{|df|
			if not df.hidden?	and not df.group?
				dfname = df.name
				if dfnamelist == nil or dfnamelist.key?(dfname) == false
					dfnamelist[ dfname ] = [ pc,vol,ar,w,h,d ]
				end
			end
		}

		#p savefile

		cr = "\n"
		readUnits()
		#@u_len
		#@u_are
		#@u_vol

		shtm  = xmlss_header()
		shtm << xmlss_styles()
		shtm << '
<Worksheet ss:Name="' + langconv("UnitPricingList") + '">
<Table>
	<Column ss:AutoFitWidth="0" ss:Width="100"/>
	<Column ss:AutoFitWidth="0" ss:Width="160"/>
	<Column ss:AutoFitWidth="0" ss:Width="100"/>
	<Column ss:AutoFitWidth="0" ss:Width="100"/>
	<Column ss:AutoFitWidth="0" ss:Width="100"/>
	<Column ss:AutoFitWidth="0" ss:Width="100"/>
	<Column ss:AutoFitWidth="0" ss:Width="100"/>
	<Row ss:StyleID="dark_gray">
	   <Cell><Data ss:Type="String">' + langconv('Definition NAME') + '</Data></Cell>
	   <Cell><Data ss:Type="String">' + langconv('SOLID MATERIAL') + '</Data></Cell>
	   <Cell><Data ss:Type="String">' + langconv('Units') + ' (' + langconv('Price') + '/' + langconv('pc') + ')</Data></Cell>
	   <Cell><Data ss:Type="String">' + langconv('VolumeUnit') + ' (' + langconv('Price') + '/' + @u_vol + ')</Data></Cell>
	   <Cell><Data ss:Type="String">' + langconv('AreaUnit') + ' (' + langconv('Price') + '/' + @u_are + ')</Data></Cell>
	   <Cell><Data ss:Type="String">' + langconv('LengthUnit') + ' (' + langconv('Price') + '/' + @u_len + ')</Data></Cell>
	   <Cell><Data ss:Type="String">' + langconv('HeightUnit') + ' (' + langconv('Price') + '/' + @u_len + ')</Data></Cell>
	   <Cell><Data ss:Type="String">' + langconv('DepthUnit') + ' (' + langconv('Price') + '/' + @u_len + ')</Data></Cell>
	</Row>
'
#sprintf( "%.3f", pvol)
dfnamelist.sort_by{|dfname , list| dfname }.each{|dfname,list|
	pc,v,ar,w,h,d = list
	matname = ""
	shtm << '
		<Row>
			<Cell><Data ss:Type="String">' + dfname + '</Data></Cell>
			<Cell><Data ss:Type="String">' + matname + '</Data></Cell>
			<Cell><Data ss:Type="String">' + pc.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + v.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + ar.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + w.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + h.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + d.to_s + '</Data></Cell>
		</Row>'
}
materiallist.sort_by{|matname,list| matname }.each{|matname,list|
	if matname != ""
	pc,v,ar,w,h,d = list
	dfname = ""
	shtm << '
		<Row>
			<Cell><Data ss:Type="String">' + dfname + '</Data></Cell>
			<Cell><Data ss:Type="String">' + matname + '</Data></Cell>
			<Cell><Data ss:Type="String">' + pc.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + v.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + ar.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + w.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + h.to_s + '</Data></Cell>
			<Cell><Data ss:Type="String">' + d.to_s + '</Data></Cell>
		</Row>'
	end
}
		shtm << xmlss_worksheet_end()
		shtm << xmlss_footer()

		xf = File.new(savefile, "w")
		Sketchup.set_status_text langconv("exporting to") + ":" + savefile

		xf.puts shtm
		xf.close
		Sketchup.active_model.set_attribute("SolidQuantify", "UnitPricesLINK" , savefile.dump )
		Sketchup.set_status_text langconv("Finished")
	end
	def changePricingfile()
	    model = Sketchup.active_model
	    ents = model.entities
	    sels = model.selection
		open_filename = ""
		open_filename = UI.openpanel langconv("Open units pricing as XML File"), "", "*.price.xml"
		#openfile = File.expand_path(open_filename)
		if open_filename
			if File.exists?( open_filename )
			else
				save_filename = char_conv(save_filename)
				#charconv_on_OS(open_filename)
				#open_filename = @filename
			end
			Sketchup.active_model.set_attribute("SolidQuantify", "UnitPricesLINK" , open_filename.dump )
		else
			Sketchup.active_model.set_attribute("SolidQuantify", "UnitPricesLINK" , nil )
		end
		#materiallist , dfnamelist = getpricinglist
		#p "material list"
		#p materiallist.inspect.dump
		#p "dfname list"
		#p dfnamelist.inspect.dump
	end
	def getpricinglist( open_filename = "" )
		if open_filename == ""
			open_filename = Sketchup.active_model.get_attribute("SolidQuantify", "UnitPricesLINK" )
			#p open_filename
		end
		if open_filename == nil
			return Hash.new , Hash.new
		end

	    model = Sketchup.active_model
	    ents = model.entities
	    sels = model.selection
		#open_filename = ""

		#open_filename = UI.openpanel "Open units pricing as XML File", "", "*.price.xml"

		#openfile = File.expand_path(open_filename)
		openfile = eval(open_filename)
		openfile.gsub!(/\//,'\\')

		if not File.exist?( openfile )
			changePricingfile
			open_filename = Sketchup.active_model.get_attribute("SolidQuantify", "UnitPricesLINK" )
			if open_filename == nil
				return Hash.new , Hash.new
			end
			openfile = eval(open_filename)
			openfile.gsub!(/\//,'\\')
		end
		if not File.exist?( openfile )
			UI.messagebox langconv("File do not exist!")
			return
		end
		if File.extname(openfile).upcase != ".XML"
			UI.messagebox langconv("This is not xml!")
			return
		end

		#p openfile.dump
		tbuff = ""
		xf = File.open(openfile, "r")
		Sketchup.set_status_text langconv("reading from") + ":" + openfile
		xf.each{|line_p|
			line_p.chomp!.strip!
			tbuff = tbuff + line_p if line_p != nil and line_p != ""
		}
		#tbuff = xf.read
		xf.close
		#tbuff.gsub!(/\n/,"")#改行を削除する
#基本的表形式としては
#<Worksheet>
#<Table>
#<Row>
#<Cell><Data>  </Data></Cell>
#</Row>
#</Table>
#</Worksheet>
#となている前提で１行にセルは１つのみとする。
#行は歯抜けになっていても詰めて考えるのでss indexは無視する。あくまで順番どおり
		sheets = Hash.new
		row = 0
		col = 0
		cells = []
		wsheets = tbuff.split(/<\/Worksheet>/)
		wsheets.each{|ws|
			if /\<[ss:]*Worksheet ss:Name=\"([^>]*)\">/ =~ ws
				chksheet = true
				sheetname = $1.to_s
				#p '///worksheet///' + sheetname
				
				sheets[ sheetname ] = []
				tbs = ws.split(/<Table[^>]*>/)
				(1..(tbs.size - 1)).each{|ti|
					tb = tbs[ti]
				#tbs.each{|tb|
					if tb != nil
						rws = tb.split(/<\/Row>/)
						rws.each{|rw|
							#p '///row///' + rw
							
							ces = rw.split(/<\/Cell>/)
							(0..(ces.size - 1)).each{|ci|
								ce = ces[ci]
								#p '///cell///' + ce
								if ce != nil
									if  /\<Cell([^>]*)><Data[^>].*>(.*)<\/Data>/ =~ ce
										cellatts = $1.to_s
										ele = $2.to_s
										if ele == nil
											#p ele
											ele = ""
										end
										#p 'element' + ele + '///'
										celmerge = 1
										celindex = col
										celmerge = $1.to_i if /ss:MergeAcross=\"(\d*)\"/ =~ cellatts
										celindex = ( $1.to_i - 1 )  if /ss:Index=\"(\d*)\"/ =~ cellatts
										col = celindex
										cells[col] = ele
										col = col + celmerge
									end
								end
							}
							row += 1
							col = 0
							cells.each{|cel|
								cel = "" if cel == nil
							}
							sheets[ sheetname ].push cells if cells.join("") != ""
							cells = []
						}
					end
				}
				row = 0
				col = 0
			end
		}
		#materiallist = Sketchup.active_model.get_attribute("SolidQuantify", "UnitPrices:Materials")
		#dfnamelist = Sketchup.active_model.get_attribute("SolidQuantify", "UnitPrices:dfname")
		materiallist = Hash.new
		dfnamelist = Hash.new
		rowcels = sheets["UnitPricingList"]

		rowmax = rowcels.size
		if rowmax > 1
			(1..rowmax-1).each{|i|
				dfname , matname , pc , v , ar , w , h , d = rowcels[i]
				#p rowcels[i].join(",")
				if dfname != nil and dfname != ""
					dfnamelist[ dfname ] = [ pc , v , ar , w , h , d ]
					#dfnamelist.push [ dfname , pc , v , ar , w , h , d ]
					#p 'dfname' + dfname + '//' + ar.to_s
					#p dfname + dfnamelist[dfname].join(",")
				elsif matname != nil and matname != ""
					materiallist[ matname ] = [ pc , v , ar , w , h , d ]
					#materiallist.push [ matname , pc , v , ar , w , h , d ]
					#p 'matname' + matname + '//'
					#p matname + materiallist[matname].join(",")
				end
			}
		end

		#Sketchup.active_model.set_attribute("SolidQuantify", "UnitPrices:Materials" , materiallist.inspect.gsub( 39.chr , '&quot;' ).gsub( 34.chr , "'") )
		#Sketchup.active_model.set_attribute("SolidQuantify", "UnitPrices:dfname" , dfnamelist.inspect.gsub( 39.chr , '&quot;' ).gsub( 34.chr , "'") )
		#Sketchup.active_model.set_attribute("SolidQuantify", "UnitPrices:Materials" , materiallist.inspect.dump
		#Sketchup.active_model.set_attribute("SolidQuantify", "UnitPrices:dfname" , dfnamelist.inspect.dump

		Sketchup.set_status_text "Finished"
		p "finished"
		return materiallist , dfnamelist
	end
	def array2eval( arr )
		newarr = []
		arr.each{|ar|
			begin
				newarr.push eval( ar.to_s ).to_f
			rescue
				newarr.push 0
			end
		}
		return newarr
	end
	def xmlss_header
	shtm  = '<?xml version="1.0"?>
	<?mso-application progid="Excel.Sheet"?>
	<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:x="urn:schemas-microsoft-com:office:excel"
	xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
	xmlns:html="http://www.w3.org/TR/REC-html40">
	<ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel">
	</ExcelWorkbook>'
	return shtm
	end
	def xmlss_styles()
	shtm = '
	<Styles>
		<Style ss:ID="Default" ss:Name="Normal">
			<Alignment ss:Vertical="Center"/>
			<Borders/>
			<Font/>
			<Interior/>
			<NumberFormat/>
			<Protection/>
		</Style>
		<Style ss:ID="light_gray">
			<Interior ss:Color="#D9D9D9" ss:Pattern="Solid"/>
		</Style>
		<Style ss:ID="dark_gray">
			<Interior ss:Color="#969696" ss:Pattern="Solid"/>
		</Style>
		<Style ss:ID="black_white">
			<Font ss:Color="#FFFFFF"/>
			<Interior ss:Color="#000000" ss:Pattern="Solid"/>
		</Style>
		<Style ss:ID="num_vol">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_vol + '&quot;"/>
		</Style>
		<Style ss:ID="num_vol_lg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#D9D9D9" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_vol + '&quot;"/>
		</Style>
		<Style ss:ID="num_vol_dg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#969696" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_vol + '&quot;"/>
		</Style>

		<Style ss:ID="num_area">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_are + '&quot;"/>
		</Style>
		<Style ss:ID="num_area_lg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#D9D9D9" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_are + '&quot;"/>
		</Style>
		<Style ss:ID="num_area_dg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#969696" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_are + '&quot;"/>
		</Style>

		<Style ss:ID="num_length">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_len + '&quot;"/>
		</Style>
		<Style ss:ID="num_length_lg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#D9D9D9" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_len + '&quot;"/>
		</Style>
		<Style ss:ID="num_length_dg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#969696" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_len + '&quot;"/>
		</Style>
		
		<Style ss:ID="num_cost">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_cost + '&quot;"/>
		</Style>
		<Style ss:ID="num_cost_lg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#D9D9D9" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_cost + '&quot;"/>
		</Style>
		<Style ss:ID="num_cost_dg">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Interior ss:Color="#969696" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_cost + '&quot;"/>
		</Style>
		<Style ss:ID="num_cost_bw">
			<Alignment ss:Horizontal="Right" ss:Vertical="Center"/>
			<Font ss:Color="#FFFFFF"/>
			<Interior ss:Color="#000000" ss:Pattern="Solid"/>
			<NumberFormat ss:Format="0.000&quot; ' + @u_cost + '&quot;"/>
		</Style>
		<Style ss:ID="su_mat">
			<Font ss:Color="#3333FF"/>
		</Style>
		<Style ss:ID="comp_ins">
			<Font ss:Color="#009900"/>
		</Style>

	</Styles>'
	return shtm
	end
	def xmlss_subtotal( ppname , ppmat , pvol , parea , pwidth , pheight , pdepth , pcost )
		shtm = '
		<Row ss:StyleID="light_gray">
			<Cell><Data ss:Type="String">' + ppname +'</Data></Cell>
			<Cell ss:MergeAcross="4"><Data ss:Type="String">"' + ppmat + '" SUBTOTAL</Data></Cell>
			<Cell ss:StyleID="light_gray" ><Data ss:Type="Number">0</Data></Cell>
			<Cell ss:StyleID="num_vol_lg"><Data ss:Type="Number">' + pvol.to_s + '</Data></Cell>
			<Cell ss:StyleID="num_area_lg"><Data ss:Type="Number">' + parea.to_s + '</Data></Cell>
			<Cell ss:StyleID="num_length_lg"><Data ss:Type="Number">' + pwidth.to_s + '</Data></Cell>
			<Cell ss:StyleID="num_length_lg"><Data ss:Type="Number">' + pheight.to_s + '</Data></Cell>
			<Cell ss:StyleID="num_length_lg"><Data ss:Type="Number">' + pdepth.to_s + '</Data></Cell>
			<Cell ss:StyleID="num_cost_lg"><Data ss:Type="Number">' + pcost.to_s + '</Data></Cell>
		</Row>'
		return shtm
	end#def
	def xmlss_worksheet_start( sheet_title )
		shtm = '
		<Worksheet ss:Name="' + sheet_title + '">
		<Table>
			<Column ss:AutoFitWidth="0" ss:Width="100"/>
			<Column ss:AutoFitWidth="0" ss:Width="160"/>
			<Column ss:AutoFitWidth="0" ss:Width="85"/>
			<Column ss:AutoFitWidth="0" ss:Width="85"/>
			<Column ss:AutoFitWidth="0" ss:Width="85"/>
			<Column ss:AutoFitWidth="0" ss:Width="75"/>
			<Column ss:AutoFitWidth="0" ss:Width="75"/>
			<Column ss:AutoFitWidth="0" ss:Width="75"/>
			<Column ss:AutoFitWidth="0" ss:Width="75"/>
			<Column ss:AutoFitWidth="0" ss:Width="75"/>
			<Column ss:AutoFitWidth="0" ss:Width="75"/>
			<Row ss:StyleID="dark_gray">
			   <Cell><Data ss:Type="String">' + langconv('PARENTNAME') + '</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('NAME') + '</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('SOLID MATERIAL') + '</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('CLASS') + '</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('TAG') + '</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('PROFILE') + '</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('COUNT(pc)') + '</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('VOLUME') + '(' + @u_vol + ')</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('AREA') + '(' + @u_are + ')</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('LENGTH(WIDTH)') + '(' + @u_len + ')</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('HEIGHT') + '(' + @u_len + ')</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('DEPTH') + '(' + @u_len + ')</Data></Cell>
			   <Cell><Data ss:Type="String">' + langconv('COST') + '(' + @u_cost + ')</Data></Cell>
			</Row>
		'
		return shtm
	end#def
	def xmlss_row( parentname , name , bmat , bclass , btag , bprofile , cntstr , vstr , arstr , xstr , ystr , zstr , cost )
		if bclass == langconv("SURFACE_MATERIAL")
			shtm = '<Row ss:StyleID="su_mat">'
		elsif bclass == langconv("COMPONENTINSTANCE")
			shtm = '<Row ss:StyleID="comp_ins">'
		else
			shtm = '<Row>'
		end
		shtm << '
				<Cell><Data ss:Type="String">' + parentname + '</Data></Cell>
				<Cell><Data ss:Type="String">' + name + '</Data></Cell>
				<Cell><Data ss:Type="String">' + bmat + '</Data></Cell>
				<Cell><Data ss:Type="String">' + bclass + '</Data></Cell>
				<Cell><Data ss:Type="String">' + btag + '</Data></Cell>
				<Cell><Data ss:Type="String">' + bprofile + '</Data></Cell>
				<Cell><Data ss:Type="Number">' + cntstr + '</Data></Cell>
				<Cell ss:StyleID="num_vol"><Data ss:Type="Number">' + vstr + '</Data></Cell>
				<Cell ss:StyleID="num_area"><Data ss:Type="Number">' + arstr + '</Data></Cell>
				<Cell ss:StyleID="num_length"><Data ss:Type="Number">' + xstr + '</Data></Cell>
				<Cell ss:StyleID="num_length"><Data ss:Type="Number">' + ystr + '</Data></Cell>
				<Cell ss:StyleID="num_length"><Data ss:Type="Number">' + zstr + '</Data></Cell>
				<Cell ss:StyleID="num_cost"><Data ss:Type="Number">' + cost.to_s + '</Data></Cell>
			</Row>'
		return shtm
	end#def
	def xmlss_total( mat , vol , area , width , height , depth , cost , cnt )
		shtm = '
			<Row ss:StyleID="dark_gray">
				<Cell ss:MergeAcross="5"><Data ss:Type="String">' + mat +' TOTAL</Data></Cell>
				<Cell ss:StyleID="dark_gray" ><Data ss:Type="Number">' + cnt.to_s + '</Data></Cell>
				<Cell ss:StyleID="num_vol_dg"><Data ss:Type="Number">' + vol.to_s + '</Data></Cell>
				<Cell ss:StyleID="num_area_dg"><Data ss:Type="Number">' + area.to_s + '</Data></Cell>
				<Cell ss:StyleID="num_length_dg"><Data ss:Type="Number">' + width.to_s + '</Data></Cell>
				<Cell ss:StyleID="num_length_dg"><Data ss:Type="Number">' + height.to_s + '</Data></Cell>
				<Cell ss:StyleID="num_length_dg"><Data ss:Type="Number">' + depth.to_s + '</Data></Cell>
				<Cell ss:StyleID="num_cost_dg"><Data ss:Type="Number">' + cost.to_s + '</Data></Cell>
			</Row>'
		return shtm
	end#def
	def xmlss_totaltotal( totalacross )
		shtm = '<Row ss:StyleID="black_white">
					<Cell><Data ss:Type="String">COST TOTALS</Data></Cell>
					<Cell ss:Index="13" ss:StyleID="num_cost_bw" ss:Formula="=SUM(R[' + totalacross.to_s + ']C:R[-1]C)"><Data ss:Type="Number">0</Data></Cell>
				</Row>'
		return shtm
	end#def
	def xmlss_worksheet_end()
		shtm = '
			</Table>
			<WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel">
				<PageSetup>
					<Header x:Margin="0.3"/>
					<Footer x:Margin="0.3"/>
					<PageMargins x:Bottom="0.75" x:Left="0.7" x:Right="0.7" x:Top="0.75"/>
				</PageSetup>
				<Selected/>
				<FreezePanes/>
				<FrozenNoSplit/>
				<SplitHorizontal>1</SplitHorizontal>
				<TopRowBottomPane>1</TopRowBottomPane>
				<ActivePane>2</ActivePane>
				<Panes>
				<Pane>
					<Number>3</Number>
				</Pane>
				<Pane>
					<Number>2</Number>
				</Pane>
				</Panes>
				<ProtectObjects>False</ProtectObjects>
				<ProtectScenarios>False</ProtectScenarios>
			</WorksheetOptions>
		</Worksheet>'
		return shtm
	end#def
	def xmlss_footer
		shtm = '
		</Workbook>'
		return shtm
	end
	def html_header()
		shtm = '<html lang="ja"><head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
		<style type="text/css">
		<!--
		table.taksq{
			width:100%;
			border-top:0px;
			border-left:0px;
			border-collapse:collapse;
			border-spacing:0px;
			empty-cells:show;
		}
		.taksq td{
			border-right:1px;
			border-bottom:1px;
			padding:0.2em 0.2em;
			font-size:9pt;
		}
		.taksq th{
			border-right:1px;
			border-bottom:1px;
			padding:0.2em 0.2em;
			font-size:9pt;
		}
		-->
		</style>'
		shtm << "
		</head><body scroll=yes><basefont size='2'>
		<script type='text/javascript'>
		<!--
			function select_ele(p){
			window.location='skp:select_entity@' + String( p ) ;
			}
		--></script>
		<table class='taksq' border='1' cellpadding='5' cellspacing='1' >
		<colgroup>
			<col width='50' align='center'>
			<col span='2' width='70' align='center'>
		</colgroup>
		<tr>
			<th>" + langconv("PARENT NAME") + "</th>
			<th>" + langconv("NAME") + "</th>
			<th>" + langconv("SOLID MATERIAL") + "</th>
			<th>" + langconv("CLASS") + "</th>
			<th>" + langconv("TAG") + "</th>
			<th>" + langconv("PROFILE") + "</th>
			<th>" + langconv("COUNT(pc)") + "</th>
			<th>" + langconv("VOLUME") + "<br>(#{@u_vol})</th>
			<th>" + langconv("AREA") + "<br>(#{@u_are})</th>
			<th>" + langconv("LENGTH") + "<br>(WIDTH)<br>(#{@u_len})</th>
			<th>" + langconv("HEIGHT") + "<br>(#{@u_len})</th>
			<th>" + langconv("DEPTH") + "<br>(#{@u_len})</th>
			<th>" + langconv("COST") + "<br>(#{@u_cost})</th>
			<th>" + langconv("entityID") + "</th>
		</tr>
		"
		return shtm
	end
	def html_subtotal( ppname , ppmat , pvol , parea , pwidth , pheight , pdepth , pcost )
		shtm = "<tr bgcolor = '#808080' >
			<td>#{ppname}</td>
			<td colspan = '5'>'#{ppmat}' " + langconv("SUBTOTAL") + "</td>
			<td>#{sprintf( "%.3f", 0 )}</td>
			<td>#{sprintf( "%.3f", pvol)}</td>
			<td>#{sprintf( "%.3f", parea)}</td>
			<td>#{sprintf( "%.3f", pwidth)}</td>
			<td>#{sprintf( "%.3f", pheight)}</td>
			<td>#{sprintf( "%.3f", pdepth)}</td>
			<td>#{sprintf( "%.3f", pcost)}</td>
			</tr>
		"
		return shtm
	end#def
	def html_row( parentname , name , bmat , bclass , btag , bprofile , cntstr , vstr , arstr , xstr , ystr , zstr , cost , eID = "" )
		if bclass == langconv("SURFACE_MATERIAL")
			shtm = '<tr bgcolor="#99ffff">'
		elsif bclass == langconv("COMPONENTINSTANCE")
			shtm = '<tr bgcolor="#99ff99">'
		else
			shtm = '<tr>'
		end
		shtm << "
			<td>" + parentname + "</td>
			<td>" + name + "</td>
			<td>" + bmat + "</td>
			<td>" + bclass + "</td>
			<td>" + btag + "</td>
			<td>" + bprofile + "</td>
			<td>" + cntstr + "</td>
			<td>" + vstr + "</td>
			<td>" + arstr + "</td>
			<td>" + xstr + "</td>
			<td>" + ystr + "</td>
			<td>" + zstr + "</td>
			<td>" + cost.to_s + "</td>
		"
		if eID != ""
			shtm << "	<td><button type='button' onclick='select_ele(#{eID})'>#{eID}</button></td>"
		end
		shtm << "
		</tr>
		"
		return shtm
	end#def
	def html_total( mat , vol , area , width , height , depth , cost , cnt )
		shtm = '
		<tr bgcolor="#969696">
			<td colspan="6">' + mat + ' TOTAL</td>
			<td>' + cnt.to_s + '</td>
			<td>' + vol.to_s + '</td>
			<td>' + area.to_s + '</td>
			<td>' + width.to_s + '</td>
			<td>' + height.to_s + '</td>
			<td>' + depth.to_s + '</td>
			<td>' + cost.to_s + '</td>
		</tr>'
		return shtm
	end
	def html_totaltotal( totalacross , totalcost )
		shtm = '
		<tr bgcolor="#000000" >
			<td colspan="12"><font color="#FFFFFF">COST TOTALS</font></td>
			<td><font color="#FFFFFF">' + totalcost.to_s + '</font></td>
		</FONT></tr>'
		return shtm
	end#def
	def chk_extname( filename , extname )
		##File.extname(openfile).upcase != ".XML"
		#if File.extname(filename).upcase == extname.upcase
		#	return filename
		#else
		#	return filename + extname
		#end
		if filename.upcase[ ( filename.size - extname.size )..( filename.size - 1 ) ] == extname.upcase
			return filename
		else
			return filename + extname
		end
	end
	def wd_solid_material_changer
		materiallist , dfnamelist = getpricinglist
		cr = "\n"
		shtm = '<html lang="ja"><head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
		<style type="text/css">
		<!--
		-->
		</style>'
		shtm << "
		</head><body scroll=yes><basefont size='2'>
		<script type='text/javascript'>
		<!--
			function change_solid_mat(p){
				window.location='skp:change_solid_material' ;
			}
			function select_solids(p){
				window.location='skp:select_solids' ;
			}
			function select_without(p){
				window.location='skp:select_without' ;
			}
			function get_selected(p){
				window.location='skp:get_selected' ;
			}
			function select_bymat(p){
				window.location='skp:select_bymat' ;
			}
			function select_by_str(smat){
				var combo = document.frm.solid_materail;
				var len = combo.options.length;
				for( i = 0; i < len; i++ ) {
					if( combo.options[i].text == smat ){
						combo.selectedIndex = i;
					}
				}
			}
			function add_new_solid_material(p){
				var smname = frm.SOLIDMATNAME.value;
				if ( smname != '' ){
					var o = document.createElement('option');
					o.innerHTML = smname;
					o.value= smname;
					frm.solid_materail.appendChild(o);
					select_by_str(smname);
				}
			}
		--></script>
		<form name='frm' >
		<select name='solid_materail' size='1' style='font-size:12px; width:200px;'>
		<option selected='selected' value=''></option>
		"
		#i = 0
		materiallist.each{|key ,val|
			shtm << "<option value='#{key}' "
			#shtm << "selected='selected'" if i == 0
			shtm << ">#{key}</option>" + cr
			#i += 1
		}
		shtm << "
		</select>
		<input type='button' name='APPLY' value='" + langconv("APPLY") + "' onClick='change_solid_mat(this)' style='font-size:12px; width:100px;'><BR>
		<input type='text' name='SOLIDMATNAME' value='' style='font-size:12px; width:200px;'>
		<input type='button' name='ADDNEWMAT' value='" + langconv("ADD_NEW") + "' onClick='add_new_solid_material(this)' style='font-size:12px; width:100px;'><BR>
		<input type='button' name='getSelected' value='" + langconv("Get Solid Material From Selected.") + "' onClick='get_selected(this)' style='font-size:12px; width:300px;'><BR>
		<input type='button' name='selectsolids' value='" + langconv("Select Solids") + "' onClick='select_solids(this)' style='font-size:12px; width:300px;'><BR>
		<input type='button' name='selectwithout' value='" + langconv("Select No Material Solids") + "' onClick='select_without(this)' style='font-size:12px; width:300px;'>
		<input type='button' name='selectbymat' value='" + langconv("Select by Current Material") + "' onClick='select_bymat(this)' style='font-size:12px; width:300px;'>
		</form></table></body></html>
		"

		mdlg = UI::WebDialog.new( langconv("SOLID MATERIAL CHANGER"), true, "SOLID_MATERIAL_CHANGER", 350, 300, 150, 150, true )
		mdlg.set_html( shtm )
		mdlg.add_action_callback("select_solids"){|d,p| select_only_Volumes }
		mdlg.add_action_callback("select_without"){|d,p| select_bySOLIDMAT }
		mdlg.add_action_callback("select_bymat"){|d,p|
			scmat = mdlg.get_element_value("solid_materail")
			select_bySOLIDMAT scmat
		}
		
		mdlg.add_action_callback("get_selected"){|d,p| 
			sel = Sketchup.active_model.selection
			smat = ""
			if sel.count > 0
				sel.each{|se|
					smat = se.get_attribute( "BEAM_SPECS","MATERIAL", "" )
					break if smat != ""
				}
			end
			if smat != ""
				mdlg.execute_script( "select_by_str('" + smat + "')" )
			end
		}
		mdlg.add_action_callback("change_solid_material"){|d,p|
			solid_material = mdlg.get_element_value("solid_materail")
			nocount = []
			Sketchup.active_model.selection.each{|e|
				vol = getVolume(e)
				if vol == nil
				elsif vol == 0
					nocount.push e
				elsif vol > 0.0
					e.set_attribute( "BEAM_SPECS","MATERIAL", solid_material )
				else
				end
			}
			Sketchup.active_model.selection.clear
			if nocount.size > 0
				nocount.each{|ne|
					Sketchup.active_model.selection.add ne
				}
				UI.messagebox "#{nocount.size} " + langconv("non Solid entities are remaining")
			end
		}

		if RUBY_PLATFORM[/darwin/]
			mdlg.show_modal { }
		else
			mdlg.show { }
		end
		
	end

	def select_only_Volumes()
		sel = Sketchup.active_model.selection
		if sel.count > 0
			sel2 = []
			sel.each{|se|
				if se.layer.visible? and se.visible?
					v = getVolume( se )
					if v == nil
					elsif v > 0.0 and
						sel2.push se
					end
				end
			}
			sel.clear
			sel.add sel2
		else
			selectVolumetrics
		end
	end
	def select_bySOLIDMAT( scmat = "" )
		sel = Sketchup.active_model.selection
		if sel.count > 0
			sel2 = []
			sel.each{|se|
				if se.layer.visible? and se.visible?
					v = getVolume( se)
					sm = se.get_attribute( "BEAM_SPECS","MATERIAL", "" )
					if v == nil
					elsif v > 0.0 and sm == scmat
						sel2.push se
					end
				end
			}
			sel.clear
			sel.add sel2
		else
			selectVolumetrics2 scmat
		end
	end
	def selectVolumetrics( pents = Sketchup.active_model.active_entities )
		sel = Sketchup.active_model.selection

			#if parent.kind_of? Sketchup::ComponentInstance
			#	pents = parent.definition.entities
			#else
			#	pents = parent.entities
			#end

			pents.each{|ent|
				if ent.layer.visible? and ent.visible?
					v = getVolume( ent )
					if v == nil
					elsif v > 0.0
						sel.add ent
					else
						if ent.kind_of? Sketchup::ComponentInstance
							selectVolumetrics( ent.definition.entities )
						elsif ent.kind_of? Sketchup::Group
							selectVolumetrics( ent.entities )
						end
					end
				end
			}
	end
	def selectVolumetrics2( scmat , pents = Sketchup.active_model.active_entities )
		sel = Sketchup.active_model.selection
			#if parent.kind_of? Sketchup::ComponentInstance
			#	pents = parent.definition.entities
			#else
			#	pents = parent.entities
			#end

			pents.each{|ent|
				if ent.layer.visible? and ent.visible?
					v = getVolume( ent )
					sm = ent.get_attribute( "BEAM_SPECS","MATERIAL", "" )
					if v == nil
					elsif v > 0.0 and sm == scmat
						sel.add ent
					else
						if ent.kind_of? Sketchup::ComponentInstance
							selectVolumetrics2( scmat , ent.definition.entities )
						elsif ent.kind_of? Sketchup::Group
							selectVolumetrics2( scmat , ent.entities )
						end
					end
				end
			}
	end
	
	def langconv( wstr )
		if @langhash == nil
			@langhash = Hash.new
			openfile = "solid_quantify_langconv\*.rb"
			thisdir = File.dirname(File.expand_path(__FILE__))
			langfilelist = []
			Dir::chdir(thisdir)
			path = thisdir + "\/#{openfile}"
			tbuff = ""
			Dir::glob(path).each{|path|
				lang_file=File.new(path,"r")
				tbuff = lang_file.read
				lang_file.close
				break
			}
			if tbuff != ""
				langhash = eval( tbuff )
				if langhash.kind_of? Hash
					@langhash = langhash
				end
			end
		end
		chstr = ""
		if @langhash.key?( wstr ) == true and @langhash[ wstr ] != ""
			chstr = @langhash[ wstr ]
		else
			chstr = wstr
		end
	end
	def render_with_jqgrid(jqlibpath,cols,datas)
cr = "\n"	
sml = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html lang="ja"><head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<link rel="stylesheet" type="text/css" media="screen" href="' + jqlibpath + '/building_structure_tool/css/south-street/jquery-ui-1.7.3.custom.css" />
<link rel="stylesheet" type="text/css" media="screen" href="' + jqlibpath + '/building_structure_tool/css/ui.jqgrid.css" />
<script type="text/javascript" src="' + jqlibpath + '/building_structure_tool/js/jquery-1.8.2.min.js"></script>
<script type="text/javascript" src="' + jqlibpath + '/building_structure_tool/js/jquery-ui-1.8.24.custom.min.js"></script>
<script type="text/javascript" src="' + jqlibpath + '/building_structure_tool/js/i18n/grid.locale-ja.js" ></script>
<script type="text/javascript" src="' + jqlibpath + '/building_structure_tool/js/jquery.jqGrid.min.js" ></script>
<script type="text/javascript">
 	jQuery(document).ready(function()
	{
		var gridprot = {
			datatype: "local",
			colNames:["' + cols.join('","') + '"],
			colModel:[
				{index:"name", name:"name", width:100,editable:false ,sortable:false}, 
				{index:"value1", name:"value1", width:100,editable:false ,sortable:false},
			],
			beforeEditCell: function (rowid, cellname, value, iRow, iCol) {
				// クリックされたセルを記録
				savedRow = iRow;
				savedCol = iCol;
			},
			cellEdit: true,    // true: クリックしたセルの編集
			cellsubmit: "clientArray",
			//scroll:true,
			viewrecords: true,
			hiddengrid: false,
			height:"auto"
		};
'

dname = []
dcount = 0
@rows.each{| cells |
	dcount += 1
	dname[dcount] = dicname.strip.gsub(/[\#\"\'\!\\]+/,"_")
	sml << 'var ' + dname[dcount] + '= [' + "\n"
	smlarr = []
	(cols.size).times{|t|
	"'{" + cols[t] + cells[t]
		smlarr.push '{name:"' + key.to_s + '",value1:"' + val.to_s + '"}'
	}
	sml << smlarr.join(",\n") + "\n"
	sml << '];
		gridprot.caption = "' + dicname + '";
		gridprot.data = ' + dname[dcount] + ';
		jQuery("#' + dname[dcount] + '").jqGrid( gridprot );' + "\n"
}
dcount += 1
sml << '	});
</script>
</head><body scroll=yes>
<form name="frm_attribute" >' + "\n"
dcount.times{|i|
sml << '<table id="' + dname[i] + '"></table>' + "\n"
}
sml << '</form>
</body></html>' + cr
	return sml
	end
	def show_qcswitch_webdialog()
		dfs = Sketchup.active_model.definitions
		return if dfs.count == 0
		shtm = "<!DOCTYPE html>
	<html>
	<head>
	<meta http-equiv='Content-Type' content='text/html; charset=utf-8' />
	<title>SELECT QUANTIFY(pc) COMPONENT</title>
	<script type='text/javascript'>
		function flipcolor(t){
			var btnid = 'SQDF' + t;
			var chkid = 'CHKSQDF' + t;
			var btn = document.getElementById(btnid);
			var chk = document.getElementById(chkid);
			if( chk.checked == true ){
				btn.style.background = '#444444';
				chk.checked = false;
			}else{
				btn.style.background = '';
				chk.checked = true;
			}
			do_attr_change(btn,chk);
		}
		function flipcolor_bycheck(t){
			var btnid = 'SQDF' + t;
			var chkid = 'CHKSQDF' + t;
			var btn = document.getElementById(btnid);
			var chk = document.getElementById(chkid);
			if( chk.checked == false ){
				btn.style.background = '#444444';
			}else{
				btn.style.background = '';
			}
			do_attr_change(btn,chk);
		}
		function do_attr_change(btn,chk){

			document.getElementById('SENDNAME').value = btn.value;
			if( chk.checked == true ){
				document.getElementById('SENDONOFF').value = 'ON';
			}else{
				document.getElementById('SENDONOFF').value = '';
			}
			cmd = 'skp:change_df_chk_attr';
			window.location = cmd;
		}
	</script>
	</head>
	<body>
	<input name='SENDNAME' id='SENDNAME' value='' type='hidden' / >
	<input name='SENDONOFF' id='SENDONOFF' value='' type='hidden' / >
	<table border = 0><tbody>\n"
		@idhash = Hash.new
		t = 0
		dfs.each{|df|
			next if df.group?
			t += 1
			shtm << "<tr><td>"
			#shtm << df.name + "\n</td><td>"
			#shtm << "<select name='SQDF#{t}' id='SQDF#{t}' >" + "\n"
			@idhash[ df.name ] = "SQDF#{t}"
			chk =  df.get_attribute( "SOLID_QUANTIFY" , "ONOFF" , "" )
			if chk == ""
				if df.hidden?
					chk = false
				else
					chk = true
				end
				df.set_attribute( "SOLID_QUANTIFY" , "ONOFF" , chk )
			end
			
			if chk == true
				shtm << "<input type='button' style='WIDTH:200px;' "
				shtm << "value='#{df.name}' id='SQDF#{t}' onClick='flipcolor(\"#{t}\")' >" + "\n"
				shtm << "</td><td><input type='checkbox' name='CHKSQDF#{t}' id='CHKSQDF#{t}' value='true' checked onClick='flipcolor_bycheck(\"#{t}\")'>" + "\n"
			else
				shtm << "<input type='button' style='WIDTH:200px;background-color:#444444;' "
				shtm << "value='#{df.name}' id='SQDF#{t}' onClick='flipcolor(\"#{t}\")' >" + "\n"
				shtm << "</td><td><input type='checkbox' name='CHKSQDF#{t}' id='CHKSQDF#{t}' value='false' onClick='flipcolor_bycheck(\"#{t}\")'>" + "\n"
			end
			shtm << "<BR></td></tr>" + "\n"
		}
		shtm <<"</tbody></table></form></body></html>"
		prfkeys = { 
			:dialog_title => 'QUANTIFY_COMPONENT_SWITCH', 
			:scrollable => true, 
			:preferences_key => 'QUANTIFY_COMPONENT_SWITCH', 
			:height => 550, 
			:width => 375, 
			:left => 150, 
			:top => 150, 
			:resizable => true, 
			:mac_only_use_nswindow => true
		} 
		$tak2sqswch_wdlg.close if $tak2sqswch_wdlg
		$tak2sqswch_wdlg = UI::WebDialog.new( prfkeys )

		$tak2sqswch_wdlg.set_on_close{
			$tak2sqswch_wdlg = nil
		}
		$tak2sqswch_wdlg.add_action_callback("change_df_chk_attr"){|d,prm|
			dfname = $tak2sqswch_wdlg.get_element_value("SENDNAME")
			onoff = $tak2sqswch_wdlg.get_element_value("SENDONOFF")

			df = Sketchup.active_model.definitions[ dfname ]
			if df
				if onoff == "ON"
					df.set_attribute( "SOLID_QUANTIFY" , "ONOFF" , true )
				else
					df.set_attribute( "SOLID_QUANTIFY" , "ONOFF" , false )
				end
			end
		}	
		$tak2sqswch_wdlg.set_html( shtm )	##変更箇所

		if RUBY_PLATFORM[/darwin/]
			$tak2sqswch_wdlg.show_modal
		else
			$tak2sqswch_wdlg.show
		end
	end
	def add_menu
#result = UI.messagebox "[YES6] to XML <-> [NO7] to CSV [CANCEL]to Display now.", MB_YESNOCANCEL 
tksq2_menu = UI.menu("Plugins").add_submenu("Solid Quantify2")
tksq2_menu.add_item("Export XML" ) { solid_quantification( 6 ) }
tksq2_menu.add_item("Export CSV" ) { solid_quantification( 7 ) }
tksq2_wd_menu = tksq2_menu.add_submenu("SHOW in WEBDIALOG")
tksq2_wd_menu.add_item("SHORT REPORT" ) { solid_quantification( 1 ) }
tksq2_wd_menu.add_item("FULL REPORT" ) { solid_quantification( 0 ) }
tksq2_wd_menu.add_item("Chart about Volumes" ) { solid_quantifycation_json( true ) }
tksq2_wd_menu.add_item("Chart about Areas" ) { solid_quantifycation_json( false ) }
tksq2_menu.add_separator
tksq2_menu.add_item("Export and Attach UnitPricing XML" ) { export_unitpricing_list }
tksq2_menu.add_item("Attach UnitPricing XML" ) { changePricingfile }
tksq2_menu.add_separator
tksq2_menu.add_item("SOLID MATERIAL DIALOG" ) { wd_solid_material_changer }
tksq2_menu.add_separator
tksq2_menu.add_item("Change Units" ) { changeUnits }
tksq2_menu.add_item("Each component quantify ON/OFF" ) { show_qcswitch_webdialog }
tksq2_menu.add_item("About This" ) { 
UI.messagebox("Solid Quantify2
By TAK2HATA
General disclaimer
The author of this script MAKES NO GUARANTEE OF VALIDITY about this script.
Please use this script at your own risk.
免責事項
このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
")
		}
	end
end#class
unless( file_loaded?( __FILE__ ) )
tak_sq2 = TAK_SQ2.new
tak_sq2.add_menu
end
####################################################################
end##module

file_loaded( __FILE__ )
